package db

import (
	"applet/app/db/model"
	"applet/app/utils"
	"errors"
	"xorm.io/xorm"
)

func GetTaskCenterRewardList(sess *xorm.Session, id string) *model.TaskCenterRewardList {
	var data model.TaskCenterRewardList
	get, err := sess.Where("id=?", id).Get(&data)
	if get == false || err != nil {
		return nil
	}
	return &data
}

func GetTaskTotal(sess *xorm.Session, uid, date, month, coinId, types, taskType, title, amount string) error {
	var data model.TaskRewardTotal
	get, _ := sess.Where("uid=? and date=? and coin_id=? and type=? and task_type=?", uid, date, coinId, types, taskType).Get(&data)
	if get == false {
		data = model.TaskRewardTotal{
			Uid:      utils.StrToInt(uid),
			Date:     utils.StrToInt(date),
			CoinId:   utils.StrToInt(coinId),
			Sum:      "0",
			Month:    utils.StrToInt(month),
			Type:     types,
			TaskType: taskType,
			Title:    title,
		}
		one, err := sess.InsertOne(&data)
		if one == 0 || err != nil {
			return errors.New("失败")
		}
	}
	data.Sum = utils.Float64ToStrByPrec(utils.StrToFloat64(amount)+utils.StrToFloat64(data.Sum), 9)
	update, err := sess.Where("id=?", data.Id).Cols("sum").Update(&data)
	if update == 0 || err != nil {
		return errors.New("失败")
	}
	return nil
}
