package model

import (
	"time"
)

type FinWithdrawApply struct {
	Id                 int64     `json:"id" xorm:"pk autoincr BIGINT(20)"`
	Uid                int       `json:"uid" xorm:"not null default 0 comment('用户ID') index INT(10)"`
	AdmId              int       `json:"adm_id" xorm:"not null default 0 comment('审核人ID,0为系统自动') INT(10)"`
	FeeType            int       `json:"fee_type" xorm:"not null default 0 comment('审核人ID,0为系统自动') INT(10)"`
	Amount             string    `json:"amount" xorm:"not null default 0.00 comment('提现金额') DECIMAL(10,2)"`
	Memo               string    `json:"memo" xorm:"not null default '' comment('备注,失败请备注原因') VARCHAR(500)"`
	Type               int       `json:"type" xorm:"not null default 1 comment('提现类型；1：手动；2：自动') TINYINT(1)"`
	WithdrawAccount    string    `json:"withdraw_account" xorm:"not null default '' comment('提现账号') VARCHAR(64)"`
	WithdrawName       string    `json:"withdraw_name" xorm:"not null default '' comment('提现人姓名') VARCHAR(12)"`
	Reason             int       `json:"reason" xorm:"not null default 0 comment('审核失败（驳回理由）；1：当前账号不满足提现规则；2：账号异常；3：资金异常') TINYINT(1)"`
	CreateAt           time.Time `json:"create_at" xorm:"not null default CURRENT_TIMESTAMP comment('申请时间') TIMESTAMP"`
	UpdateAt           time.Time `json:"update_at" xorm:"not null default CURRENT_TIMESTAMP comment('处理时间') TIMESTAMP"`
	State              int       `json:"state" xorm:"not null default 0 comment('0申请中,1通过,2完成,3失败') TINYINT(1)"`
	WithdrawRefundType int       `json:"withdraw_refund_type" xorm:"not null default 0 comment('') TINYINT(1)"`
	WithdrawDealType   int       `json:"withdraw_deal_type" xorm:"not null default 0 comment('') TINYINT(1)"`
	WithdrawMoney      string    `json:"withdraw_money"  xorm:"not null default '' comment('') VARCHAR(255)" `
}
