package db

import (
	"applet/app/db"
	"applet/app/flexible_employment/db/model"
	"applet/app/utils/logx"
	"xorm.io/xorm"
)

type FlexibleEmploymentBasicDb struct {
	Db *xorm.Engine `json:"model"`
}

func (flexibleEmploymentBasicDb *FlexibleEmploymentBasicDb) Set() { // set方法
	flexibleEmploymentBasicDb.Db = db.Db
}

func (flexibleEmploymentBasicDb *FlexibleEmploymentBasicDb) Get(masterId string) (m *model.FlexibleEmploymentBasic, err error) {
	m = new(model.FlexibleEmploymentBasic)
	has, err := flexibleEmploymentBasicDb.Db.Where("master_id = ?", masterId).Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (flexibleEmploymentBasicDb *FlexibleEmploymentBasicDb) GetBasicByAppKey(appKey string) (m *model.FlexibleEmploymentBasic, err error) {
	m = new(model.FlexibleEmploymentBasic)
	has, err := flexibleEmploymentBasicDb.Db.Where("app_key = ?", appKey).Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}
