package db

import (
	"applet/app/db"
	"applet/app/flexible_employment/db/model"
	"applet/app/utils/logx"
	"xorm.io/xorm"
)

type FlexibleEmploymentOrdDb struct {
	Db *xorm.Engine `json:"model"`
}

func (flexibleEmploymentOrdDb *FlexibleEmploymentOrdDb) Set(masterId string) { // set方法
	flexibleEmploymentOrdDb.Db = db.DBs[masterId]
}

func (flexibleEmploymentOrdDb *FlexibleEmploymentOrdDb) Get(requestId string) (m *model.FlexibleEmploymentOrd, err error) {
	m = new(model.FlexibleEmploymentOrd)
	has, err := flexibleEmploymentOrdDb.Db.Where("request_id = ?", requestId).Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (flexibleEmploymentOrdDb *FlexibleEmploymentOrdDb) Update(id interface{}, m *model.FlexibleEmploymentOrd, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = flexibleEmploymentOrdDb.Db.Where("id=?", id).Cols(forceColums...).Update(m)
	} else {
		affected, err = flexibleEmploymentOrdDb.Db.Where("id=?", id).Update(m)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}
