package db

import (
	"applet/app/db"
	"applet/app/flexible_employment/db/model"
	"applet/app/utils/logx"
	"xorm.io/xorm"
)

type FlexibleEmploymentPupiaoOrdDb struct {
	Db *xorm.Engine `json:"model"`
}

func (flexibleEmploymentPupiaoOrdDb *FlexibleEmploymentPupiaoOrdDb) Set(masterId string) { // set方法
	flexibleEmploymentPupiaoOrdDb.Db = db.DBs[masterId]
}

func (flexibleEmploymentPupiaoOrdDb *FlexibleEmploymentPupiaoOrdDb) Get(outBatchNo string) (m *model.FlexibleEmploymentPupiaoOrd, err error) {
	m = new(model.FlexibleEmploymentPupiaoOrd)
	has, err := flexibleEmploymentPupiaoOrdDb.Db.Where("out_batch_no = ?", outBatchNo).Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (flexibleEmploymentPupiaoOrdDb *FlexibleEmploymentPupiaoOrdDb) Update(id interface{}, m *model.FlexibleEmploymentPupiaoOrd, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = flexibleEmploymentPupiaoOrdDb.Db.Where("id=?", id).Cols(forceColums...).Update(m)
	} else {
		affected, err = flexibleEmploymentPupiaoOrdDb.Db.Where("id=?", id).Update(m)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}
