package model

type FlexibleEmploymentOrd struct {
	Id                         int    `json:"id" xorm:"not null pk autoincr INT(11)"`
	Uid                        int    `json:"uid" xorm:"not null default 0 comment('用户id') INT(11)"`
	ServiceId                  string `json:"service_id" xorm:"not null default '' comment('服务主体id') VARCHAR(255)"`
	RequestId                  string `json:"request_id" xorm:"not null default '' comment('提现记录ID') VARCHAR(255)"`
	Mobile                     string `json:"mobile" xorm:"not null default '' comment('手机号') VARCHAR(255)"`
	Name                       string `json:"name" xorm:"not null default '' comment('姓名') VARCHAR(255)"`
	Amount                     string `json:"amount" xorm:"not null default 0.00 comment('提现金额') DECIMAL(8,2)"`
	Identity                   string `json:"identity" xorm:"not null default 0.00 comment('证件号码') DECIMAL(8,2)"`
	BankAccount                string `json:"bank_account" xorm:"not null default 0 comment('入款账号 银行卡提现此字段传入员工绑定的银行卡，支付宝提现此字段请传入员工绑定的支付宝账号') TINYINT(1)"`
	SettleType                 string `json:"settle_type" xorm:"not null default '' comment('商户提现账户类型 银行通道:BANK, 微信通道:WECHAT, 支付宝通道:ALIPAY 例如：传BANK会从商户银行账户扣款') CHAR(50)"`
	CallbackDataForTradeResult string `json:"callback_data_for_trade_result" xorm:"not null comment('交易结果通知') TEXT"`
	State                      int    `json:"state" xorm:"not null default 0 comment('状态(0:待提交易 1:已提交交易 2:交易成功 3:交易失败)') TINYINT(1)"`
	CreateAt                   string `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
	UpdateAt                   string `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('更新时间') DATETIME"`
}
