package model

type FlexibleEmploymentPupiaoOrd struct {
	Id                          int    `json:"id" xorm:"not null pk autoincr INT(11)"`
	Uid                         int    `json:"uid" xorm:"not null default 0 comment('用户id') INT(11)"`
	WithdrawApplyId             int64  `json:"withdraw_apply_id" xorm:"not null default 0 comment('提现记录ID') BIGINT(20)"`
	OutBatchNo                  string `json:"out_batch_no" xorm:"not null default '' comment('外部商户批次订单号') VARCHAR(255)"`
	PlatformBatchNo             string `json:"platform_batch_no" xorm:"not null default '' comment('平台批次订单号') VARCHAR(255)"`
	TotalAmount                 string `json:"total_amount" xorm:"not null default 0.00 comment('总金额') DECIMAL(8,2)"`
	ValidTotalFeeAmount         string `json:"valid_total_fee_amount" xorm:"not null default 0.00 comment('平台总服务费金额') DECIMAL(8,2)"`
	BatchStatus                 int    `json:"batch_status" xorm:"not null default 0 comment('批次状态(0:待创建 1:制单失败 2:待确认支付 3:支付成功 4:支付失败)') TINYINT(1)"`
	SettleType                  string `json:"settle_type" xorm:"not null default '' comment('结算方式（CARD：银行卡，ALIPAY：支付宝，WECHAT：微信）') CHAR(50)"`
	PayeeNo                     string `json:"payee_no" xorm:"not null default '' comment('收款人账户') CHAR(50)"`
	PayeePhone                  string `json:"payee_phone" xorm:"not null default '' comment('收款人手机号') CHAR(50)"`
	PayeeName                   string `json:"payee_name" xorm:"not null default '' comment('收款人姓名') CHAR(50)"`
	PayeeIdCard                 string `json:"payee_id_card" xorm:"not null default '' comment('收款人身份证号') CHAR(50)"`
	CallbackDataForReceiveOrder string `json:"callback_data_for_receive_order" xorm:"not null comment('制单回调通知') TEXT"`
	CallbackDataForTradeResult  string `json:"callback_data_for_trade_result" xorm:"not null comment('交易结果通知') TEXT"`
	CreateAt                    string `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
	UpdateAt                    string `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('更新时间') DATETIME"`
}
