package model

type FlexibleEmploymentUserInfo struct {
	Id                       int    `json:"id" xorm:"not null pk autoincr INT(11)"`
	Uid                      int    `json:"uid" xorm:"not null default 0 INT(11)"`
	Name                     string `json:"name" xorm:"not null default '' comment('姓名') VARCHAR(255)"`
	Mobile                   string `json:"mobile" xorm:"not null default '' comment('手机号') VARCHAR(255)"`
	Identity                 string `json:"identity" xorm:"not null default '' comment('证件号码') VARCHAR(255)"`
	BankAccountNo            string `json:"bank_account_no" xorm:"not null default '' comment('默认银行账号') VARCHAR(255)"`
	AlipayAccountNo          string `json:"alipay_account_no" xorm:"not null default '' comment('默认支付宝账号') VARCHAR(255)"`
	IdentityFrontBase64      string `json:"identity_front_base64" xorm:"not null comment('证件头像面图片base64（图片大小不能超过3M）') TEXT"`
	IdentityBackgroundBase64 string `json:"identity_background_base64" xorm:"not null comment('证件国徽面图片base64（图片大小不能超过3M）') TEXT"`
	ContractId               string `json:"contract_id" xorm:"not null comment('合同id') CHAR(50)"`
	State                    int    `json:"state" xorm:"not null default 0 comment('状态(0:未签约（员工未同步） 1:待签约（员工已同步，但未确认签约）2:签约文件生成中（用户已确认签署，合同文件正在生成，此状态可发起提现） 3:签约完成 （用户已签约，签约合同生成完成）)') TINYINT(1)"`
	CreateAt                 string `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
	UpdateAt                 string `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('更新时间') DATETIME"`
}
