package md

type CallbackRequestForPuPiao struct {
	AppId           string `json:"appId"`           //appId
	PlatformOrderNo string `json:"platformOrderNo"` //平台订单号
	NotifyType      string `json:"notifyType"`      //通知业务类型
	NotifyContent   string `json:"notifyContent"`   //业务参数加密密文 （根据不同通知类型解密后参数不同，具体请参考通知类型参数说明）
	Sign            string `json:"sign"`            //签名字符串
}

type CallbackRequestForPuPiaoByRECEIVEORDER struct {
	PlatformBatchNo     string `json:"platformBatchNo"`     //平台批次订单号
	OutBatchNo          string `json:"outBatchNo"`          //外部商户批次订单号
	TotalCount          string `json:"totalCount"`          //总笔数
	TotalAmount         string `json:"totalAmount"`         //总金额
	ValidTotalCount     string `json:"validTotalCount"`     //有效订单（平台收单成功）-总笔数
	ValidTotalAmount    string `json:"validTotalAmount"`    //有效订单（平台收单成功）-总金额
	ValidTotalFeeAmount string `json:"validTotalFeeAmount"` //有效订单（平台收单成功）-平台总服务费金额
	BatchStatus         string `json:"batchStatus"`         //批次状态 RECEIVE_FAIL:收单失败（整批次下全部失败） WAIT_CONFIRM:待确认支付（有效订单笔数大于0时，为此批次状态）
	ItemList            []struct {
		PlatformOrderNo string `json:"platformOrderNo"` //单笔平台订单号
		OutTradeNo      string `json:"outTradeNo"`      //单笔外部商户订单号（批次下唯一不可重复）
		SettleType      string `json:"settleType"`      //结算方式（CARD：银行卡，ALIPAY：支付宝，WECHAT：微信）
		PayeeName       string `json:"payeeName"`       //收款人姓名
		PayeeIdCard     string `json:"payeeIdCard"`     //收款人身份证号
		PayeePhone      string `json:"payeePhone"`      //收款人手机号
		PayeeNo         string `json:"payeeNo"`         //收款人账户
		OrderAmount     string `json:"orderAmount"`     //订单金额（最多保留两位小数）
		OrderStatus     string `json:"orderStatus"`     //单笔订单状态，见以下取值范围 RECEIVE_FAIL：收单失败 WAIT_CONFIRM：待确认支付
		PayeeBankName   string `json:"payeeBankName"`   //收款人银行名称
		PayeeBranchNo   string `json:"payeeBranchNo"`   //收款人分行联行号
		OrderMemo       string `json:"orderMemo"`       //付款备注摘要
		FeeAmount       string `json:"feeAmount"`       //单笔平台服务费金额
		ErrorCode       string `json:"errorCode"`       //单笔异常code
		ErrorMsg        string `json:"errorMsg"`        //单笔异常msg
	} `json:"itemList"` //批次明细list
}

type CallbackRequestForPuPiaoByTRADERESULT struct {
	PlatformBatchNo string `json:"platformBatchNo"` //平台批次订单号
	OutBatchNo      string `json:"outBatchNo"`      //外部商户批次订单号
	PlatformOrderNo string `json:"platformOrderNo"` //单笔平台订单号
	OutTradeNo      string `json:"outTradeNo"`      //单笔外部商户订单号（批次下唯一不可重复）
	SettleType      string `json:"settleType"`      //结算方式（CARD：银行卡，ALIPAY：支付宝，WECHAT：微信）
	PayeeName       string `json:"payeeName"`       //收款人姓名
	PayeeIdCard     string `json:"payeeIdCard"`     //收款人身份证号
	PayeePhone      string `json:"payeePhone"`      //收款人手机号
	PayeeNo         string `json:"payeeNo"`         //收款人账户
	OrderAmount     string `json:"orderAmount"`     //订单金额（最多保留两位小数）
	OrderStatus     string `json:"orderStatus"`     //单笔订单状态，见以下取值范围 RECEIVE_FAIL：收单失败 WAIT_CONFIRM：待确认支付
	TradeTime       string `json:"tradeTime"`       //交易时间（格式 yyyy-MM-dd HH:mm:ss）
	PayeeBankName   string `json:"payeeBankName"`   //收款人银行名称
	PayeeBranchNo   string `json:"payeeBranchNo"`   //收款人分行联行号
	OrderMemo       string `json:"orderMemo"`       //付款备注摘要
	FeeAmount       string `json:"feeAmount"`       //单笔平台服务费金额
	ErrorCode       string `json:"errorCode"`       //单笔异常code
	ErrorMsg        string `json:"errorMsg"`        //单笔异常msg
}
