package svc

import (
	"applet/app/db"
	"applet/app/db/model"
	"applet/app/utils"
	"applet/app/utils/logx"
	"errors"
	"time"
	"xorm.io/xorm"
)

func ExchangeUserVirFinValidAndInterFlowWithSession(session *xorm.Session, money float64, Title, fee string, types, transferType, uid, coinId, coinIdTo int, ordId int64, coinTransferJson string, transferId, toUid int64) (int64, error) {
	UserVirtualAmount, err := db.UserVirtualAmountFindByIdWithSession(session, uid, coinId)
	if err != nil || UserVirtualAmount == nil {
		if err == nil {
			err = errors.New("获取用户余额信息失败")
		}
		return 0, err
	}
	beforeAmount := UserVirtualAmount.Amount
	afterAmount := ""
	if types == 1 {
		afterAmount = utils.Float64ToStrByPrec(utils.AnyToFloat64(UserVirtualAmount.Amount)+money, 6)
		UserVirtualAmount.Amount = utils.GetPrec(utils.Float64ToStrByPrec(utils.AnyToFloat64(UserVirtualAmount.Amount)+money, 5), "4")
	} else if types == 2 {
		afterAmount = utils.Float64ToStrByPrec(utils.AnyToFloat64(UserVirtualAmount.Amount)-money, 6)
		UserVirtualAmount.Amount = utils.GetPrec(utils.Float64ToStrByPrec(utils.AnyToFloat64(UserVirtualAmount.Amount)-money, 5), "4")
		if utils.StrToInt64(UserVirtualAmount.Amount) < 0 {
			_ = session.Rollback()
			err = errors.New("余额不足")
			return 0, err
		}

	}
	affected, err := db.UserVirtualAmountUpdateWithSession(session, uid, coinId, UserVirtualAmount, "amount")
	if err != nil || affected == 0 {
		if err == nil {
			err = errors.New("更新用户余额信息失败")
		}
		return 0, err
	}
	id, err := virtualCoinFlowInsert(session, uid, coinId, coinIdTo, utils.Float64ToStrByPrec(money, 8), fee, ordId, Title, types, transferType, beforeAmount, afterAmount, coinTransferJson, transferId, toUid)
	if err != nil {
		return 0, err
	}
	return id, nil
}

func virtualCoinFlowInsert(session *xorm.Session, uid, coinId, coinIdTo int, money, SysFee string, ordId int64, ItemTitle string, types, transferType int, beforeAmount string, afterAmount, coinTransferJson string, transferId, toUid int64) (int64, error) {
	now := time.Now()
	data := &model.UserVirtualCoinFlow{
		Uid:              uid,
		OrdId:            utils.Int64ToStr(ordId),
		CoinId:           coinId,
		CoinIdTo:         coinIdTo,
		Direction:        types,
		Title:            ItemTitle,
		Amout:            money,
		BeforeAmout:      beforeAmount,
		AfterAmout:       afterAmount,
		SysFee:           SysFee,
		CreateTime:       now,
		TransferType:     transferType,
		CoinTransferData: coinTransferJson,
		TransferId:       int(transferId),
		ToUid:            int(toUid),
		Date:             now.Format("2006-01"),
	}
	if err := db.UserVirtualCoinFlowInsertOneWithSession(
		session, data); err != nil {
		_ = logx.Warn(err)
		return 0, err
	}
	return data.Id, nil
}
