package svc

import (
	"applet/app/cfg"
	db2 "applet/app/db"
	"applet/app/svc"
	"applet/app/utils"
	"applet/cloud_issuance/db"
	"applet/cloud_issuance/enum"
	"applet/cloud_issuance/md"
	db3 "applet/super_cloud_issuance/db"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/chain_transfer"
	cache2 "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils/cache"
	"fmt"
	"github.com/gin-gonic/gin"
	"time"
)

type DealCloudIssuanceCallBackService struct {
	Context *gin.Context `json:"context"`
}

func (dealCloudIssuanceCallBackService *DealCloudIssuanceCallBackService) Set(c *gin.Context) { // set方法
	dealCloudIssuanceCallBackService.Context = c
}

func (dealCloudIssuanceCallBackService *DealCloudIssuanceCallBackService) DealCallBack(c *gin.Context, req md.CallbackRequest) {
	//1、初始化云发单类
	cloudIssuanceService := CloudIssuanceService{}

	//1、判断是否为群组消息
	if req.Data.IsGroup {
		//2、判断消息类型
		switch req.MessageType {
		case 9:
			//群聊文本消息
			bindId := dealCloudIssuanceCallBackService.IsNeedDealGroupMessage(req.Data.FromGroup, req.Data.FromUser, req.RobotId)
			if bindId == 0 {
				return
			}
			//3、查询需转发的群
			cloudIssuanceUserRobotBindFollowGroupDb := db.CloudIssuanceUserRobotBindFollowGroupDb{}
			cloudIssuanceUserRobotBindFollowGroupDb.Set(dealCloudIssuanceCallBackService.Context)
			cloudIssuanceUserRobotBindFollowGroups, err := cloudIssuanceUserRobotBindFollowGroupDb.GetCloudIssuanceUserRobotBindFollowGroupByBindId(bindId)
			if err != nil {
				fmt.Println("DealCallBack_err::::", err.Error())
				return
			}
			cache2.NewRedis(cfg.RedisAddr)
			cloudIssuanceUserRobotBindFollowDb := db.CloudIssuanceUserRobotBindFollowDb{}
			cloudIssuanceUserRobotBindFollowDb.Set(dealCloudIssuanceCallBackService.Context, 0)
			cloudIssuanceUserRobotBindFollow, err := cloudIssuanceUserRobotBindFollowDb.GetCloudIssuanceUserRobotBindFollow(bindId)
			for _, cloudIssuanceUserRobotBindFollowGroup := range cloudIssuanceUserRobotBindFollowGroups {
				fmt.Println(cloudIssuanceUserRobotBindFollowGroup)
				cloudIssuanceService.Set(nil, enum.RobotMacSendTextMethodName, "127.0.0.1")
				//转链
				if cloudIssuanceUserRobotBindFollow.Uid > 0 {
					args := map[string]string{
						"uid":       utils.IntToStr(cloudIssuanceUserRobotBindFollow.Uid),
						"platform":  "",
						"master_id": c.GetString("mid"),
						"content":   req.Data.Content,
					}
					utils.FilePutContents("cloud", utils.SerializeStr(args))
					randInt := utils.RandIntRand(10, 100)
					time.Sleep(time.Millisecond * time.Duration(randInt)) // 等待10 ~ 100毫秒
					chain := chain_transfer.TurnChain(svc.MasterDb(c), db3.ZhimengDb, db2.Db, args)
					utils.FilePutContents("cloud_resp", utils.SerializeStr(chain))
					if chain.Count != "" {
						req.Data.Content = chain.Count
					}
				}
				utils.FilePutContents("cloud", req.Data.Content)
				err = cloudIssuanceService.RobotMacSendText(md.RobotMacSendTextRequest{
					RobotId: req.RobotId,
					WxId:    cloudIssuanceUserRobotBindFollowGroup.FollowChatRoomId,
					Content: req.Data.Content,
				})
				if err != nil {
					fmt.Println("DealCallBack_err::::", err.Error())
					return
				}
			}
			break
		case 10:
			//群聊图片消息
			bindId := dealCloudIssuanceCallBackService.IsNeedDealGroupMessage(req.Data.FromGroup, req.Data.FromUser, req.RobotId)
			if bindId == 0 {
				return
			}
			//3、查询需转发的群
			cloudIssuanceUserRobotBindFollowGroupDb := db.CloudIssuanceUserRobotBindFollowGroupDb{}
			cloudIssuanceUserRobotBindFollowGroupDb.Set(dealCloudIssuanceCallBackService.Context)
			cloudIssuanceUserRobotBindFollowGroups, err := cloudIssuanceUserRobotBindFollowGroupDb.GetCloudIssuanceUserRobotBindFollowGroupByBindId(bindId)
			if err != nil {
				fmt.Println("DealCallBack_err::::", err.Error())
				return
			}
			for _, cloudIssuanceUserRobotBindFollowGroup := range cloudIssuanceUserRobotBindFollowGroups {
				cloudIssuanceService.Set(nil, enum.RobotMacSendRecvImageMethodName, "127.0.0.1")
				err = cloudIssuanceService.RobotMacSendRecvImage(md.RobotMacSendRecvImageRequest{
					RobotId: req.RobotId,
					WxId:    cloudIssuanceUserRobotBindFollowGroup.FollowChatRoomId,
					Content: req.Data.Content,
				})
				if err != nil {
					fmt.Println("DealCallBack_err::::", err.Error())
					return
				}
			}
			break
		}
	}
}

func (dealCloudIssuanceCallBackService *DealCloudIssuanceCallBackService) IsNeedDealGroupMessage(fromGroup, fromUser string, robotId int) (bindId int) {
	//查询 "发送群号" 是否被监听
	cloudIssuanceUserRobotBindFollowDb := db.CloudIssuanceUserRobotBindFollowDb{}
	cloudIssuanceUserRobotBindFollowDb.Set(dealCloudIssuanceCallBackService.Context, 0)
	cloudIssuanceUserRobotBindFollow, err := cloudIssuanceUserRobotBindFollowDb.GetCloudIssuanceUserRobotBindFollowByChatRoomId(fromGroup, robotId)
	if err != nil {
		fmt.Println("IsNeedDealGroupMessage_Err:::::", err.Error())
		return
	}
	if cloudIssuanceUserRobotBindFollow == nil {
		return
	}

	//查询 "发送微信号" 是否被监听
	cloudIssuanceUserRobotBindFollowUserDb := db.CloudIssuanceUserRobotBindFollowUserDb{}
	cloudIssuanceUserRobotBindFollowUserDb.Set(dealCloudIssuanceCallBackService.Context)
	cloudIssuanceUserRobotBindFollowUser, err := cloudIssuanceUserRobotBindFollowUserDb.GetCloudIssuanceUserRobotBindFollowUserByWxId(fromUser)
	if err != nil {
		fmt.Println("IsNeedDealGroupMessage_Err:::::", err.Error())
		return
	}
	if cloudIssuanceUserRobotBindFollowUser == nil {
		return
	}

	bindId = cloudIssuanceUserRobotBindFollow.Id
	return
}
