package consume

import (
	"applet/app/db"
	model2 "applet/app/db/gim/model"
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
)

func CanalGimMessageConsume(queue md.MqQueue) {
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(100)
	delivery := ch.Consume(queue.Name, false)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			//fmt.Println(string(res.Body))
			fmt.Println(">>>>>>>>>>>>>>>>CanalGimMessageConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			err = handleCanalGimMessageTable(res.Body)
			if err != nil {
				fmt.Println("err ::: ", err)
				utils.FilePutContents("CanalGimMessageConsume", "[err]:"+err.Error())
				_ = res.Reject(false)
				////TODO::重新推回队列末尾，避免造成队列堵塞
				//var msg *md.OneCirclesStructForSignIn
				//json.Unmarshal(res.Body, &msg)
				//ch.Publish(queue.ExchangeName, msg, queue.RoutKey)
			} else {
				_ = res.Ack(true)
			}
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleCanalGimMessageTable(msg []byte) error {
	//1、解析canal采集至mq中queue的数据结构体
	var canalMsg *md.CanalGimMessage[md.Message]
	err := json.Unmarshal(msg, &canalMsg)
	if err != nil {
		return err
	}

	//2、判断操作(insert | update)
	if canalMsg.Type == md.CanalMsgInsertSqlType {
		for _, item := range canalMsg.Data {
			var oldM md.Message000
			get, err := db.ImDb.Table("message_000").ID(item.Id).Get(&oldM)
			if err != nil {
				return err
			}
			if get {
				message := &model2.Message{
					UserId:       oldM.UserId,
					RequestId:    oldM.RequestId,
					SenderType:   oldM.SenderType,
					SenderId:     oldM.SenderId,
					ReceiverType: oldM.ReceiverType,
					ReceiverId:   oldM.ReceiverId,
					ToUserIds:    oldM.ToUserIds,
					Type:         oldM.Type,
					Content:      oldM.Content,
					Seq:          oldM.Seq,
					SendTime:     oldM.SendTime,
					Status:       oldM.Status,
				}
				_, err = db.ImDb.InsertOne(message)
				if err != nil {
					return err
				}
			}
		}
	}

	if canalMsg.Type == md.CanalMsgUpdateSqlType {
		//查找是否有数据
		for _, item := range canalMsg.Data {
			_, err2 := db.ImDb.Where("user_id  =?", item.UserId).And("send_time =?", item.SendTime).Cols("status").Update(&model2.Message{Status: int32(utils.StrToInt(item.Status))})
			if err2 != nil {
				return err2
			}
		}
	}

	return nil
}
