package md

type MqQueue struct {
	ExchangeName   string `json:"exchangeName"`     //交换机名字
	Name           string `json:"name"`             //队列名字
	Type           string `json:"type"`             //队列类型
	IsPersistent   bool   `json:"is_persistent"`    //队列是否持久化
	RoutKey        string `json:"rout_key"`         //路由
	BindKey        string `json:"bind_key"`         //绑定的路由
	ConsumeFunName string `json:"consume_fun_name"` //消费方法
}

var RabbitMqQueueKeyList = []*MqQueue{
	{
		ExchangeName:   "",
		Name:           "cloud_issuance_async_mlogin",
		Type:           SimpleQueueType,
		IsPersistent:   false,
		RoutKey:        "",
		BindKey:        "",
		ConsumeFunName: "CloudIssuanceAsyncMLoginConsume",
	},
	{
		ExchangeName:   "",
		Name:           "super_cloud_issuance_async_mlogin",
		Type:           SimpleQueueType,
		IsPersistent:   false,
		RoutKey:        "",
		BindKey:        "",
		ConsumeFunName: "SuperCloudIssuanceAsyncMLoginConsume",
	},
	{
		ExchangeName:   "zhios.cloud.issuance.msg.callback.exchange",
		Name:           "cloud_issuance_msg_call_back",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "",
		BindKey:        "",
		ConsumeFunName: "CloudIssuanceMsgCallBackConsume",
	},
	{
		ExchangeName:   "zhios.super.cloud.issuance.msg.callback.exchange",
		Name:           "super_cloud_issuance_msg_call_back",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "",
		BindKey:        "",
		ConsumeFunName: "SuperCloudIssuanceMsgCallBackConsume",
	},
	{
		ExchangeName:   "zhios.cloud_chain.fenxiao.newChange.exchange",
		Name:           "cloud_chain_fenxiao_newChange",
		Type:           FanOutQueueType,
		IsPersistent:   false,
		RoutKey:        "",
		BindKey:        "",
		ConsumeFunName: "SupplyCloudChainFenxiaoNewChangeConsume",
	},
	{
		ExchangeName:   "zhios.addSupplyGoods.exchange",
		Name:           "mall_add_supply_goods",
		Type:           FanOutQueueType,
		IsPersistent:   false,
		RoutKey:        "",
		BindKey:        "",
		ConsumeFunName: "MallAddSupplyGoodsConsume",
	},
	{
		ExchangeName:   "canal.topic",
		Name:           "canal_order",
		Type:           TopicQueueType,
		IsPersistent:   false,
		RoutKey:        "canal_mall_order",
		BindKey:        "",
		ConsumeFunName: "CanalOrderConsume",
	},
	{
		ExchangeName:   "canal.topic",
		Name:           "canal_guide_order_for_numerical_statement",
		Type:           TopicQueueType,
		IsPersistent:   false,
		RoutKey:        "canal_order_list",
		BindKey:        "",
		ConsumeFunName: "CanalGuideOrderForNumericalStatementConsume",
	},
	{
		ExchangeName:   "canal.topic",
		Name:           "canal_mall_order_for_numerical_statement",
		Type:           TopicQueueType,
		IsPersistent:   false,
		RoutKey:        "canal_mall_order",
		BindKey:        "",
		ConsumeFunName: "CanalMallOrderForNumericalStatementConsume",
	},
	{
		ExchangeName:   "canal.topic",
		Name:           "canal_b2c_order_for_numerical_statement",
		Type:           TopicQueueType,
		IsPersistent:   false,
		RoutKey:        "canal_b2c_order",
		BindKey:        "",
		ConsumeFunName: "CanalB2cOrderForNumericalStatementConsume",
	},
	{
		ExchangeName:   "canal.topic",
		Name:           "canal_o2o_order_for_numerical_statement",
		Type:           TopicQueueType,
		IsPersistent:   false,
		RoutKey:        "canal_o2o_order",
		BindKey:        "",
		ConsumeFunName: "CanalO2oOrderForNumericalStatementConsume",
	},
	{
		ExchangeName:   "canal.topic",
		Name:           "canal_o2o_pay_order_for_numerical_statement",
		Type:           TopicQueueType,
		IsPersistent:   false,
		RoutKey:        "canal_o2o_pay_to_merchant",
		BindKey:        "",
		ConsumeFunName: "CanalO2oPayOrderForNumericalStatementConsume",
	},
	{
		ExchangeName:   "canal.topic",
		Name:           "canal_gim_message",
		Type:           TopicQueueType,
		IsPersistent:   false,
		RoutKey:        "canal_gim_message",
		BindKey:        "",
		ConsumeFunName: "CanalGimMessageConsume",
	},
	{
		ExchangeName:   "canal.topic",
		Name:           "canal_guide_order",
		Type:           TopicQueueType,
		IsPersistent:   false,
		RoutKey:        "canal_order_list",
		BindKey:        "",
		ConsumeFunName: "CanalGuideOrderConsume",
	},
	{
		ExchangeName:   "canal.topic",
		Name:           "canal_guide_order_by_user_up_lv",
		Type:           TopicQueueType,
		IsPersistent:   false,
		RoutKey:        "canal_order_list",
		BindKey:        "",
		ConsumeFunName: "CanalGuideOrderByUserUpLvConsume",
	},
	{
		ExchangeName:   "zhios.app.user.visit.ip.address.exchange",
		Name:           "zhios_user_visit_ip_address_queue",
		Type:           FanOutQueueType,
		IsPersistent:   false,
		RoutKey:        "queue_one",
		BindKey:        "",
		ConsumeFunName: "ZhiOsUserVisitIpAddressConsume",
	},
	{
		ExchangeName:   "zhios.order.fast.return.exchange",
		Name:           "zhios_fast_return_order_pay",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "order_pay",
		BindKey:        "",
		ConsumeFunName: "ZhiosFastReturnOrderPay",
	},
	{
		ExchangeName:   "zhios.order.fast.return.exchange",
		Name:           "zhios_fast_return_order_success",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "order_success",
		BindKey:        "",
		ConsumeFunName: "ZhiosFastReturnOrderSuccess",
	},
	{
		ExchangeName:   "zhios.order.fast.return.exchange",
		Name:           "zhios_fast_return_order_refund",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "order_refund",
		BindKey:        "",
		ConsumeFunName: "ZhiosFastReturnOrderRefund",
	},
	{
		ExchangeName:   "zhios.order.fast.return.exchange",
		Name:           "zhios_fast_return_order_refund_second",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "order_refund_second",
		BindKey:        "",
		ConsumeFunName: "ZhiosFastReturnOrderRefundSecond",
	},
	{
		ExchangeName:   "zhios.doushen.user.register.exchange",
		Name:           "zhios_doushen_user_register_my_fans",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "my_fans",
		BindKey:        "my_fans",
		ConsumeFunName: "DouShenUserRegisterConsumeForMyFans",
	},
	{
		ExchangeName:   "zhios.doushen.user.register.exchange",
		Name:           "zhios_doushen_user_register_operation_center",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "operation_center",
		BindKey:        "operation_center",
		ConsumeFunName: "DouShenUserRegisterConsumeForOperationCenter",
	},
	{
		ExchangeName:   "zhios.doushen.user.register.exchange",
		Name:           "zhios_doushen_user_register_my_recommender",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "my_recommender",
		BindKey:        "my_recommender",
		ConsumeFunName: "DouShenUserRegisterConsumeForMyRecommender",
	},
	{
		ExchangeName:   "zhios.doushen.user.register.exchange",
		Name:           "zhios_doushen_user_register_official",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "official",
		BindKey:        "official",
		ConsumeFunName: "DouShenUserRegisterConsumeForOfficial",
	},
	{
		ExchangeName:   "zhios.doushen.user.register.exchange",
		Name:           "zhios_doushen_user_register_user_comm_up_lv",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "user_register_comm_up_lv",
		BindKey:        "user_register_comm_up_lv",
		ConsumeFunName: "DouShenUserRegisterConsumeForUserRegisterUpLv",
	},
	{
		ExchangeName:   "canal.topic",
		Name:           "canal_mall_ord_for_you_mi_shang",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "canal_mall_order",
		BindKey:        "",
		ConsumeFunName: "CanalMallOrdForYouMiShang",
	},
	{
		ExchangeName:   "zhios.youmishang.exchange",
		Name:           "zhios_youmishang_exchange_store",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "store",
		BindKey:        "store",
		ConsumeFunName: "YoumishangExchangeStore",
	},
	{
		ExchangeName:   "zhios.recharge.order.exchange",
		Name:           "zhios_recharge_order_fail",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "order_fail",
		BindKey:        "",
		ConsumeFunName: "ZhiosRechargeOrderFail",
	},
	{
		ExchangeName:   "zhios.tikTok.exchange",
		Name:           "zhios_tikTok_update",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "update",
		BindKey:        "",
		ConsumeFunName: "ZhiosTikTokUpdate",
	},
	{
		ExchangeName:   "zhios.tikTok.exchange",
		Name:           "zhios_tikTok_all_update",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "all_update",
		BindKey:        "",
		ConsumeFunName: "ZhiosTikTokAllUpdate",
	},
	{
		ExchangeName:   "zhios.capital_pool.order_total.exchange",
		Name:           "zhios_capital_pool_order_total",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "order_total",
		BindKey:        "",
		ConsumeFunName: "ZhiosCapitalPoolOrderTotal",
	},
	{
		ExchangeName:   "zhios.acquisition.exchange",
		Name:           "zhios_acquisition_condition",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "condition",
		BindKey:        "",
		ConsumeFunName: "ZhiosAcquisitionCondition",
	},
	{
		ExchangeName:   "zhios.acquisition.exchange",
		Name:           "zhios_acquisition_condition_dev",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "acq_dev",
		BindKey:        "",
		ConsumeFunName: "ZhiosAcquisitionConditionDev",
	},
	{
		ExchangeName:   "zhios.recharge.order.exchange",
		Name:           "zhios_recharge_order_fail_dev",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "order_fail_dev",
		BindKey:        "",
		ConsumeFunName: "ZhiosRechargeOrderFailDev",
	},
	{
		ExchangeName:   "zhios.express.order.exchange",
		Name:           "zhios_express_order_fail",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "order_fail",
		BindKey:        "",
		ConsumeFunName: "zhiosExpressOrderFail",
	},
	{
		ExchangeName:   "zhios.withdraw.reward.exchange",
		Name:           "zhios_withdraw_reward",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "withdraw_reward",
		BindKey:        "",
		ConsumeFunName: "zhiosWithdrawReward",
	},
	{
		ExchangeName:   "zhios.task.exchange",
		Name:           "zhios_task_total",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "task_total",
		BindKey:        "",
		ConsumeFunName: "zhiosTaskTotal",
	},
	{
		ExchangeName:   "zhios.user_profile.exchange",
		Name:           "zhios_user_profile_invite_code",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "user_profile_invite_code",
		BindKey:        "",
		ConsumeFunName: "ZhiosUserProfileInviteCode",
	},
	{
		ExchangeName:   "zhios.user_profile.exchange",
		Name:           "zhios_auto_un_freeze",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "auto_un_freeze",
		BindKey:        "",
		ConsumeFunName: "ZhiosAutoUnFreeze",
	},
	{
		ExchangeName:   "zhios.user_valid.exchange",
		Name:           "zhios_user_valid",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "user_valid",
		BindKey:        "",
		ConsumeFunName: "ZhiosValidUser",
	},
	{
		ExchangeName:   "zhios.appreciation.exchange",
		Name:           "zhios_appreciation",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "appreciation",
		BindKey:        "",
		ConsumeFunName: "ZhiosAppreciation",
	},
	{
		ExchangeName:   "zhios.appreciation.exchange",
		Name:           "zhios_appreciation_dev",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "appreciation_dev",
		BindKey:        "",
		ConsumeFunName: "ZhiosAppreciationDev",
	},
	{
		ExchangeName:   "zhios.guide_store.exchange",
		Name:           "zhios_guide_store_order",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "guide_store_order",
		BindKey:        "",
		ConsumeFunName: "ZhiosGuideStoreOrder",
	},
	{
		ExchangeName:   "zhios.supplier_after_order.exchange",
		Name:           "zhios_supplier_after_order",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "refund",
		BindKey:        "",
		ConsumeFunName: "ZhiosSupplierAfterOrder",
	},
	{
		ExchangeName:   "zhios.order_buckle.exchange",
		Name:           "zhios_order_buckle",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "order_buckle",
		BindKey:        "",
		ConsumeFunName: "ZhiosOrderBuckle",
	},
	{
		ExchangeName:   "zhios.order_hjy.exchange",
		Name:           "zhios_order_hjy",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "order_hjy",
		BindKey:        "",
		ConsumeFunName: "ZhiosOrderHjy",
	},
	{
		ExchangeName:   "zhios.order_settle_total.exchange",
		Name:           "zhios_order_settle_total",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "order_settle_total",
		BindKey:        "",
		ConsumeFunName: "ZhiosOrderSettleTotal",
	},
	{
		ExchangeName:   "zhios.order_total.exchange",
		Name:           "zhios_order_total",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "order_total",
		BindKey:        "",
		ConsumeFunName: "ZhiosOrderTotal",
	},
	{
		ExchangeName:   "zhios.order_total.exchange",
		Name:           "zhios_order_total_second",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "order_total_second",
		BindKey:        "",
		ConsumeFunName: "ZhiosOrderTotalSecond",
	},
	{
		ExchangeName:   "zhios.order_free.exchange",
		Name:           "zhios_order_free",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "order_free",
		BindKey:        "",
		ConsumeFunName: "ZhiosOrderFree",
	},
	{
		ExchangeName:   "zhios.user_up_lv.exchange",
		Name:           "zhios_user_up_lv",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "user_up_lv",
		BindKey:        "",
		ConsumeFunName: "ZhiosUserUpLv",
	},
	{
		ExchangeName:   "zhios.integral_proxy_recharge.exchange",
		Name:           "zhios_integral_proxy_recharge",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "integral_proxy_recharge",
		BindKey:        "",
		ConsumeFunName: "ZhiosIntegralProxyRecharge",
	},
	{
		ExchangeName:   "zhios.mall_green_coin_consume.exchange",
		Name:           "zhios_mall_green_coin_consume",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "mall_green_coin_consume",
		BindKey:        "",
		ConsumeFunName: "ZhiosMallGreenCoinConsume",
	},
	{
		ExchangeName:   "canal.topic",
		Name:           "user_virtual_coin_flow_aggregation",
		Type:           TopicQueueType,
		IsPersistent:   false,
		RoutKey:        "canal_user_virtual_coin_flow_aggregation",
		BindKey:        "",
		ConsumeFunName: "ZhiosOneCirclesCoinConsume",
	},
	{
		ExchangeName:   "canal.topic",
		Name:           "canal_user_virtual_coin_flow",
		Type:           TopicQueueType,
		IsPersistent:   false,
		RoutKey:        "canal_user_virtual_coin_flow",
		BindKey:        "",
		ConsumeFunName: "CanalUserVirtualCoinFlowConsume",
	},
	{
		ExchangeName:   "one.circles",
		Name:           "one_circles_sign_in_green_energy",
		Type:           TopicQueueType,
		IsPersistent:   false,
		RoutKey:        "sign_in",
		BindKey:        "",
		ConsumeFunName: "OneCirclesSignInGreenEnergyConsume",
	},
	{
		ExchangeName:   "one.circles",
		Name:           "one_circles_start_level_dividend",
		Type:           TopicQueueType,
		IsPersistent:   false,
		RoutKey:        "star_level_dividend",
		BindKey:        "",
		ConsumeFunName: "OneCirclesStartLevelDividendConsume",
	},
	{
		ExchangeName:   "one.circles",
		Name:           "one_circles_auto_exchange_green_energy_to_person_1",
		Type:           TopicQueueType,
		IsPersistent:   false,
		RoutKey:        "auto_exchange_green_energy_to_person_1",
		BindKey:        "",
		ConsumeFunName: "OneCirclesActivityCoinAutoExchangeGreenEnergyConsume",
	},
	{
		ExchangeName:   "one.circles",
		Name:           "one_circles_auto_exchange_green_energy_to_team",
		Type:           TopicQueueType,
		IsPersistent:   false,
		RoutKey:        "auto_exchange_green_energy_to_team",
		BindKey:        "",
		ConsumeFunName: "OneCirclesActivityCoinAutoExchangeGreenEnergyForTeamConsume",
	},
	{
		ExchangeName:   "one.circles",
		Name:           "one_circles_settlement_public_give_activity_coin",
		Type:           TopicQueueType,
		IsPersistent:   false,
		RoutKey:        "settlement_public_give_activity_coin",
		BindKey:        "",
		ConsumeFunName: "OneCirclesSettlementPublicGiveActivityCoinConsume",
	},
	{
		ExchangeName:   "one.circles",
		Name:           "one_circles_add_public_platoon_user_relation_commission",
		Type:           TopicQueueType,
		IsPersistent:   false,
		RoutKey:        "add_public_platoon_user_relation_commission",
		BindKey:        "",
		ConsumeFunName: "OneCirclesAddPublicPlatoonUserRelationCommissionConsume",
	},
	{
		ExchangeName:   "one.circles",
		Name:           "one_circles_sign_in_update_records",
		Type:           TopicQueueType,
		IsPersistent:   false,
		RoutKey:        "sign_in_update_records",
		BindKey:        "",
		ConsumeFunName: "OneCirclesSignInUpdateRecordsGreenEnergyConsume",
	},
	{
		ExchangeName:   "zhios.app.user.withdraw.apply.exchange",
		Name:           "zhios_app_user_withdraw_apply_queue",
		Type:           FanOutQueueType,
		IsPersistent:   false,
		RoutKey:        "queues_one",
		BindKey:        "",
		ConsumeFunName: "WithdrawConsume",
	},
	{
		ExchangeName:   "zhios.app.user.withdraw.apply.flexible.employment.exchange",
		Name:           "zhios_app_user_withdraw_apply_gongmao_queue",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "gongmao",
		BindKey:        "",
		ConsumeFunName: "FlexibleEmploymentWithdrawForGongMaoConsume",
	},
	{
		ExchangeName:   "zhios.app.user.withdraw.apply.flexible.employment.exchange",
		Name:           "zhios_app_user_withdraw_apply_pupiao_queue",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "pupiao",
		BindKey:        "",
		ConsumeFunName: "FlexibleEmploymentWithdrawForPupiaoConsume",
	},
	{
		ExchangeName:   "installment.payment",
		Name:           "zhios_installment_payment_auto_repaid",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "auto_repaid",
		BindKey:        "",
		ConsumeFunName: "InstallmentPaymentAutoRepaidConsume",
	},
}

const (
	ZhiosUserRelateFunName                                      = "ZhiosUserRelate"
	ZhiosIntegralProxyRechargeFunName                           = "ZhiosIntegralProxyRecharge"
	ZhiosMallGreenCoinConsumeFunName                            = "ZhiosMallGreenCoinConsume"
	ZhiosOneCirclesCoinConsumeFunName                           = "ZhiosOneCirclesCoinConsume"
	ZhiosUserUpLvFunName                                        = "ZhiosUserUpLv"
	CanalGuideOrderByUserUpLvConsume                            = "CanalGuideOrderByUserUpLvConsume"
	ZhiosOrderFreeFunName                                       = "ZhiosOrderFree"
	ZhiosOrderSettleTotalFunName                                = "ZhiosOrderSettleTotal"
	ZhiosOrderTotalFunName                                      = "ZhiosOrderTotal"
	ZhiosOrderTotalSecondFunName                                = "ZhiosOrderTotalSecond"
	ZhiosOrderHjyFunName                                        = "ZhiosOrderHjy"
	ZhiosOrderBuckleFunName                                     = "ZhiosOrderBuckle"
	ZhiosSupplierAfterOrderFunName                              = "ZhiosSupplierAfterOrder"
	CanalOrderConsumeFunName                                    = "CanalOrderConsume"
	CanalGuideOrderForNumericalStatementConsumeFunName          = "CanalGuideOrderForNumericalStatementConsume"
	CanalMallOrderForNumericalStatementConsumeFunName           = "CanalMallOrderForNumericalStatementConsume"
	CanalO2oOrderForNumericalStatementConsumeFunName            = "CanalO2oOrderForNumericalStatementConsume"
	CanalO2oPayOrderForNumericalStatementConsumeFunName         = "CanalO2oPayOrderForNumericalStatementConsume"
	CanalB2cOrderForNumericalStatementConsumeFunName            = "CanalB2cOrderForNumericalStatementConsume"
	CanalGuideOrderConsumeFunName                               = "CanalGuideOrderConsume"
	ZhiOsUserVisitIpAddressConsumeFunName                       = "ZhiOsUserVisitIpAddressConsume"
	DouShenUserRegisterConsumeForOfficialFunName                = "DouShenUserRegisterConsumeForOfficial"
	DouShenUserRegisterConsumeForOperationCenterFunName         = "DouShenUserRegisterConsumeForOperationCenter"
	DouShenUserRegisterConsumeForMyRecommenderFunName           = "DouShenUserRegisterConsumeForMyRecommender"
	DouShenUserRegisterConsumeForMyFansFunName                  = "DouShenUserRegisterConsumeForMyFans"
	DouShenUserRegisterConsumeForUserRegisterUpLvFunName        = "DouShenUserRegisterConsumeForUserRegisterUpLv"
	ZhiosFastReturnOrderPayFunName                              = "ZhiosFastReturnOrderPay"
	ZhiosFastReturnOrderSuccessFunName                          = "ZhiosFastReturnOrderSuccess"
	ZhiosFastReturnOrderRefundFunName                           = "ZhiosFastReturnOrderRefund"
	ZhiosFastReturnOrderRefundSecondFunName                     = "ZhiosFastReturnOrderRefundSecond"
	CanalMallOrdForYouMiShangFunName                            = "CanalMallOrdForYouMiShang"
	YoumishangExchangeStoreFunName                              = "YoumishangExchangeStore"
	ZhiosRechargeOrderFailFunName                               = "ZhiosRechargeOrderFail"
	ZhiosRechargeOrderFailDevFunName                            = "ZhiosRechargeOrderFailDev"
	ZhiosCapitalPoolOrderTotalFunName                           = "ZhiosCapitalPoolOrderTotal"
	ZhiosExpressOrderFail                                       = "zhiosExpressOrderFail"
	ZhiosWithdrawReward                                         = "zhiosWithdrawReward"
	ZhiosTikTokUpdateFunName                                    = "ZhiosTikTokUpdate"
	ZhiosTikTokAllUpdateFunName                                 = "ZhiosTikTokAllUpdate"
	CloudIssuanceAsyncMLoginFunName                             = "CloudIssuanceAsyncMLoginConsume"
	CloudIssuanceMsgCallBackFunName                             = "CloudIssuanceMsgCallBackConsume"
	SuperCloudIssuanceAsyncMLoginFunName                        = "SuperCloudIssuanceAsyncMLoginConsume"
	SuperCloudIssuanceMsgCallBackFunName                        = "SuperCloudIssuanceMsgCallBackConsume"
	ZhiosAcquisitionConditionFunName                            = "ZhiosAcquisitionCondition"
	ZhiosValidUserFunName                                       = "ZhiosValidUser"
	ZhiosAppreciationFunName                                    = "ZhiosAppreciation"
	ZhiosAppreciationDevFunName                                 = "ZhiosAppreciationDev"
	ZhiosGuideStoreOrderFunName                                 = "ZhiosGuideStoreOrder"
	ZhiosAcquisitionConditionDevFunName                         = "ZhiosAcquisitionConditionDev"
	SupplyCloudChainFenxiaoNewChangeFunName                     = "SupplyCloudChainFenxiaoNewChangeConsume"
	MallAddSupplyGoodsFunName                                   = "MallAddSupplyGoodsConsume"
	CanalUserVirtualCcoinFlowFunName                            = "CanalUserVirtualCoinFlowConsume"
	OneCirclesSignInGreenEnergyFunName                          = "OneCirclesSignInGreenEnergyConsume"
	OneCirclesSignInUpdateRecordsGreenEnergyFunName             = "OneCirclesSignInUpdateRecordsGreenEnergyConsume"
	OneCirclesStartLevelDividendFunName                         = "OneCirclesStartLevelDividendConsume"
	OneCirclesActivityCoinAutoExchangeGreenEnergyFunName        = "OneCirclesActivityCoinAutoExchangeGreenEnergyConsume"
	OneCirclesActivityCoinAutoExchangeGreenEnergyForTeamFunName = "OneCirclesActivityCoinAutoExchangeGreenEnergyForTeamConsume"
	OneCirclesSettlementPublicGiveActivityCoinFunName           = "OneCirclesSettlementPublicGiveActivityCoinConsume"
	OneCirclesAddPublicPlatoonUserRelationCommissionFunName     = "OneCirclesAddPublicPlatoonUserRelationCommissionConsume"
	WithdrawConsumeFunName                                      = "WithdrawConsume"
	FlexibleEmploymentWithdrawForGongMaoConsumeFunName          = "FlexibleEmploymentWithdrawForGongMaoConsume"
	FlexibleEmploymentWithdrawForPupiaoConsumeFunName           = "FlexibleEmploymentWithdrawForPupiaoConsume"
	ZhiosTaskTotal                                              = "zhiosTaskTotal"
	ZhiosUserProfileInviteCode                                  = "ZhiosUserProfileInviteCode"
	ZhiosAutoUnFreeze                                           = "ZhiosAutoUnFreeze"
	InstallmentPaymentAutoRepaidConsumeFunName                  = "InstallmentPaymentAutoRepaidConsume"
	CanalGimMessageConsumeFunName                               = "CanalGimMessageConsume"
)
