package md

import "time"

type Message struct {
	Id           string `json:"id"`
	UserId       string `json:"user_id"`
	RequestId    string `json:"request_id"`
	SenderType   string `json:"sender_type"`
	SenderId     string `json:"sender_id"`
	ReceiverType string `json:"receiver_type"`
	ReceiverId   string `json:"receiver_id"`
	ToUserIds    string `json:"to_user_ids"`
	Type         string `json:"type"`
	Content      string `json:"content"`
	Seq          string `json:"seq"`
	SendTime     string `json:"send_time"`
	Status       string `json:"status"`
	CreateTime   string `json:"create_time"`
	UpdateTime   string `json:"update_time"`
}

type Message000 struct {
	Id           int64     // 自增主键
	UserId       int64     // 所属类型id
	RequestId    int64     // 请求id
	SenderType   int32     // 发送者类型
	SenderId     int64     // 发送者账户id
	ReceiverType int32     // 接收者账户id
	ReceiverId   int64     // 接收者id,如果是单聊信息，则为user_id，如果是群组消息，则为group_id
	ToUserIds    string    // 需要@的用户id列表，多个用户用，隔开
	Type         int       // 消息类型
	Content      []byte    // 消息内容
	Seq          int64     // 消息同步序列
	SendTime     time.Time // 消息发送时间
	Status       int32     // 创建时间
}

type CanalGimMessage[T any] struct {
	Data     []T      `json:"data"`
	Database string   `json:"database"`
	ES       int64    `json:"es"`
	ID       int64    `json:"id"`
	IsDdl    bool     `json:"isDdl"`
	Old      []T      `json:"old"`
	PkNames  []string `json:"pkNames"`
	Table    string   `json:"table"`
	TS       int64    `json:"ts"`
	Type     string   `json:"type"`
}
