package consume

import (
	"applet/app/cfg"
	"applet/app/db"
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	md2 "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/rule/one_circles"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
)

func OneCirclesAddPublicPlatoonUserRelationCommissionConsume(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>OneCirclesAddPublicPlatoonUserRelationCommissionConsume>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	one_circles.Init(cfg.RedisAddr)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			err = handleOneCirclesAddPublicPlatoonUserRelationCommissionConsume(res.Body)
			if err != nil {
				fmt.Println("err ::: ", err)
				utils.FilePutContents("OneCirclesAddPublicPlatoonUserRelationCommissionConsume_ERR", "[err]:"+err.Error())
				_ = res.Reject(false)
				//TODO::重新推回队列末尾，避免造成队列堵塞
				var msg *md.OneCirclesStructForAddPublicPlatoonUserRelationCommissionConsume
				json.Unmarshal(res.Body, &msg)
				ch.Publish(queue.ExchangeName, msg, queue.RoutKey)
			} else {
				_ = res.Ack(true)
			}
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleOneCirclesAddPublicPlatoonUserRelationCommissionConsume(msgData []byte) error {
	//1、解析mq中queue的数据结构体
	var msg *md.OneCirclesStructForAddPublicPlatoonUserRelationCommissionConsume
	err := json.Unmarshal(msgData, &msg)
	if err != nil {
		return err
	}

	engine := db.DBs[msg.MasterId]
	var req []*md2.AddOneCirclesPublicPlatoonUserRelationCommissionReq
	req = append(req, &msg.Data)
	_, err = one_circles.AddOneCirclesPublicPlatoonUserRelationCommission(engine, req)
	fmt.Println("err::::", err)
	if err != nil {
		return err
	}
	return nil
}
