package consume

import (
	"applet/app/cfg"
	"applet/app/db"
	utils2 "applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	md2 "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/rule"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/rule/one_circles"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
	"time"
)

func OneCirclesSettlementPublicGiveActivityCoinConsume(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>OneCirclesSettlementPublicGiveActivityCoinConsume>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	one_circles.Init(cfg.RedisAddr)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			err = handleOneCirclesSettlementPublicGiveActivityCoinConsume(res.Body)
			if err != nil {
				fmt.Println("OneCirclesSettlementPublicGiveActivityCoinConsume_ERR:::::", err.Error())
				utils2.FilePutContents("OneCirclesSettlementPublicGiveActivityCoinConsume_ERR", utils2.SerializeStr(map[string]interface{}{
					"body": res.Body,
					"err":  err.Error(),
				}))
			}
			//_ = res.Reject(false)
			err = res.Ack(true)
			fmt.Println("err ::: ", err)
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleOneCirclesSettlementPublicGiveActivityCoinConsume(msgData []byte) error {
	time.Sleep(time.Duration(2) * time.Millisecond) //休眠2毫秒
	//1、解析mq中queue的数据结构体
	var msg *md2.DealUserCoinReq
	err := json.Unmarshal(msgData, &msg)
	if err != nil {
		return err
	}
	engine := db.DBs[msg.Mid]

	session := engine.NewSession()
	defer func() {
		session.Close()
		if err := recover(); err != nil {
			_ = logx.Error(err)
		}
	}()
	session.Begin()

	err = rule.DealUserCoin(session, md2.DealUserCoinReq{
		Kind:         "add",
		Mid:          msg.Mid,
		Title:        msg.Title,
		TransferType: msg.TransferType,
		OrdId:        "",
		CoinId:       msg.CoinId,
		Uid:          msg.Uid,
		Amount:       msg.Amount,
	})
	if err != nil {
		_ = session.Rollback()
		fmt.Println("err:::::2222", err)
		return err
	}

	err = session.Commit()
	if err != nil {
		_ = session.Rollback()
		return errors.New("事务提交失败")
	}
	return nil
}
