package consume

import (
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	db "applet/super_cloud_issuance/db/official"
	md2 "applet/super_cloud_issuance/md"
	"applet/super_cloud_issuance/svc"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/gin-gonic/gin"
	"github.com/streadway/amqp"
	"time"
)

func SuperCloudIssuanceMsgCallBackConsume(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			fmt.Println(">>>>>>>>>>>>>>>>CloudIssuanceMsgCallBackConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			//解析mq中queue的数据结构体
			var msg *md2.CallbackRequest
			err = json.Unmarshal(res.Body, &msg)
			if err != nil {
				panic(err)
			}
			randInt := utils.RandIntRand(20, 100)
			time.Sleep(time.Millisecond * time.Duration(randInt)) // 等待20 ~ 100毫秒
			go func() {
				//设置masterId
				cloudIssuanceRobotRecords, err := db.SuperCloudIssuanceRobotRecordsGetOneByParams(map[string]interface{}{
					"key":   "robot_id",
					"value": msg.RobotId,
				})
				if err != nil {
					fmt.Println("CallBackErr:::::", err.Error())
					return
				}
				if cloudIssuanceRobotRecords == nil {
					//TODO::未查询到机器人，不需要处理
					utils.FilePutContents("cloud_issuance_call_back_not_found", utils.SerializeStr(msg))
					return
				}
				var c = &gin.Context{}
				c.Set("mid", cloudIssuanceRobotRecords.MasterId)
				dealCloudIssuanceCallBackService := svc.DealSuperCloudIssuanceCallBackService{}
				dealCloudIssuanceCallBackService.Set(c)
				dealCloudIssuanceCallBackService.DealCallBack(c, *msg)
			}()
			_ = res.Ack(true)
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}
