package consume

import (
	"applet/app/cfg"
	"applet/app/db"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/rule/installment_payment"
	md2 "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/rule/installment_payment/md"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
	"time"
)

func InstallmentPaymentAutoRepaidConsume(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			//fmt.Println(string(res.Body))
			fmt.Println(">>>>>>>>>>>>>>>>InstallmentPaymentAutoRepaidConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			err = handleInstallmentPaymentAutoRepaidConsume(ch, res.Body)
			if err != nil {
				fmt.Println("handleInstallmentPaymentAutoRepaidConsumeERR:::::", err.Error())
			}
			//_ = res.Reject(false)
			err = res.Ack(true)
			fmt.Println("err ::: ", err)
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleInstallmentPaymentAutoRepaidConsume(ch *rabbit.Channel, msgData []byte) error {
	time.Sleep(time.Duration(1) * time.Millisecond) //休眠1毫秒

	//1、解析mq中queue的数据结构体
	var msg *md2.InstallmentPaymentStructForAutoRepaid
	err := json.Unmarshal(msgData, &msg)
	if err != nil {
		return err
	}
	engine := db.DBs[msg.MasterId]
	installment_payment.Init(cfg.RedisAddr)
	//2、调用 `DealInstallmentPaymentAutoRepaid` 制度方法进行扣款
	err = installment_payment.DealInstallmentPaymentAutoRepaid(engine, ch, *msg, msg.MasterId)
	return nil
}
