package consume

import (
	"applet/app/db"
	"applet/app/db/model"
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/shopspring/decimal"
	"github.com/streadway/amqp"
	"strings"
	"time"
)

func ZhiosOneCirclesCoinConsume(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(50)
	delivery := ch.Consume(queue.Name, false)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			//fmt.Println(string(res.Body))
			fmt.Println(">>>>>>>>>>>>>>>>ZhiosOneCirclesCoinConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			err = handleZhiosOneCirclesCoinConsume(res.Body)
			if err != nil {
				fmt.Println("handleZhiosOneCirclesCoinConsume:::::", err.Error())
			}
			//_ = res.Reject(false)
			err = res.Ack(true)
			fmt.Println("err ::: ", err)
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleZhiosOneCirclesCoinConsume(msg []byte) error {
	//1、解析canal采集至mq中queue的数据结构体
	var canalMsg *md.CanalUserVirtualCoinFlowOrderMessage[md.CanalUserVirtualCoinFlowOrder]
	err := json.Unmarshal(msg, &canalMsg)
	if err != nil {
		return err
	}
	masterId := strings.Split(canalMsg.Database, "_")[1]
	if masterId != "31585332" {
		return nil
	}
	engine := db.DBs[masterId]
	now := time.Now()

	if canalMsg.Type == md.CanalMsgInsertSqlType {
		////2、查找 one_circles_green_energy_basic_setting 基础设置
		//userPublicPlatoonDoubleNetworkSetting, err := db.UserPublicPlatoonDoubleNetworkSettingGetOneByParams(engine, map[string]interface{}{
		//	"key":   "is_open",
		//	"value": 1,
		//})
		//if err != nil {
		//	return err
		//}

		if canalMsg.Data[0].CoinId == utils.IntToStr(7) { //TODO::数据量太大，减少查询直接写死
			//3、查找 user_public_platoon_double_network_user_coin_record
			userVirtualCoinFlowAggregation, err1 := db.UserVirtualCoinFlowAggregationGetOneByParams(engine, map[string]interface{}{
				"key":   "uid",
				"value": canalMsg.Data[0].Uid,
			})
			if err1 != nil {
				return err1
			}
			if userVirtualCoinFlowAggregation == nil {
				//新增记录
				_, err3 := db.UserVirtualCoinFlowAggregationInsert(engine, &model.UserVirtualCoinFlowAggregation{
					Uid:           utils.StrToInt(canalMsg.Data[0].Uid),
					CoinId:        utils.StrToInt(canalMsg.Data[0].CoinId),
					TodayData:     canalMsg.Data[0].Amout,
					ThisWeekData:  canalMsg.Data[0].Amout,
					ThisMonthData: canalMsg.Data[0].Amout,
					NowData:       canalMsg.Data[0].Amout,
					CreateAt:      now.Format("2006-01-02 15:04:05"),
					UpdateAt:      now.Format("2006-01-02 15:04:05"),
				})
				if err3 != nil {
					return err3
				}
			} else {
				//更新记录
				amount, _ := decimal.NewFromString(canalMsg.Data[0].Amout)
				todayData, _ := decimal.NewFromString(userVirtualCoinFlowAggregation.TodayData)
				thisWeekData, _ := decimal.NewFromString(userVirtualCoinFlowAggregation.ThisWeekData)
				thisMonthData, _ := decimal.NewFromString(userVirtualCoinFlowAggregation.ThisMonthData)
				userVirtualCoinFlowAggregation.TodayData = todayData.Add(amount).String()
				userVirtualCoinFlowAggregation.ThisWeekData = thisWeekData.Add(amount).String()
				userVirtualCoinFlowAggregation.ThisMonthData = thisMonthData.Add(amount).String()
				userVirtualCoinFlowAggregation.NowData = canalMsg.Data[0].AfterAmout
				_, err2 := db.UserVirtualCoinFlowAggregationUpdate(engine, userVirtualCoinFlowAggregation.Id, userVirtualCoinFlowAggregation, "today_data", "this_week_data", "this_month_data", "now_data")
				if err2 != nil {
					return err2
				}
			}
		}
	}
	return nil
}
