package consume

import (
	"applet/app/db"
	"applet/app/utils/logx"
	"applet/consume/md"
	"applet/mall/utils"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
	"math/rand"
	"unicode"
	"xorm.io/xorm"
)

func ZhiosUserProfileInviteCode(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			//fmt.Println(string(res.Body))
			fmt.Println(">>>>>>>>>>>>>>>>CanalOrderConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			err = UserProfileInviteCode(res.Body)
			//_ = res.Reject(false)
			if err == nil {
				_ = res.Ack(true)
				//TODO::重新推回队列末尾，避免造成队列堵塞
				var msg *md.ZhiosUserProfile
				var tmpString string
				err := json.Unmarshal(res.Body, &tmpString)
				if err != nil {
					return
				}
				fmt.Println(tmpString)
				err = json.Unmarshal([]byte(tmpString), &msg)
				if err != nil {
					return
				}
				ch.Publish(queue.ExchangeName, utils.SerializeStr(msg), queue.RoutKey)
			}
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func UserProfileInviteCode(msg []byte) error {
	//1、解析canal采集至mq中queue的数据结构体
	var canalMsg *md.ZhiosUserProfile
	fmt.Println(string(msg))
	var tmpString string
	err := json.Unmarshal(msg, &tmpString)
	if err != nil {
		fmt.Println(err.Error())
		return err
	}
	fmt.Println(tmpString)
	err = json.Unmarshal([]byte(tmpString), &canalMsg)
	if err != nil {
		return err
	}
	mid := canalMsg.Mid
	eg := db.DBs[mid]
	if eg == nil {
		return nil
	}
	userProfile, _ := db.UserProfileFindByID(eg, canalMsg.Uid)
	if userProfile == nil {
		return nil
	}
	if userProfile.InviteCode != "" {
		return nil
	}
	inviteData := db.SysCfgFindWithDb(eg, mid, "app_invite_length", "app_invite_type")
	l := utils.StrToInt(inviteData["app_invite_length"])
	types := utils.StrToInt(inviteData["app_invite_type"])
	code := returnCode(eg, l, types, 0)
	if code == "" {
		return errors.New("继续")
	}
	userProfile.InviteCode = code
	fmt.Println(userProfile)
	_, err = db.UserProfileUpdate(eg, userProfile.Uid, userProfile, "invite_code")
	if err != nil {
		return nil
	}
	return nil
}
func IsLetter(s string) bool {
	for _, r := range s {
		if !unicode.IsLetter(r) {
			return false
		}
	}
	return true
}

func GetRandomString(l, isLetter int) string {
	str := "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"
	if isLetter != 1 {
		str = "0123456789"
	}
	strs := []rune(str)
	result := make([]rune, l)
	for i := range result {
		result[i] = strs[rand.Intn(len(strs))]
	}
	if IsLetter(string(result)) && isLetter == 1 {
		return GetRandomString(l, isLetter)
	}
	return string(result)
}

func returnCode(eg *xorm.Engine, l, types, num int) string {
	if num > 5 {
		return ""
	}
	//循环3次判断是否存在该邀请码
	var code string
	var (
		codes []string
	)
	for i := 0; i < 3; i++ {
		oneCode := GetRandomString(l, types)
		codes = append(codes, oneCode)
	}

	//判断是不是存在邀请码了
	tmp, _ := db.UserProfileFindByInviteCodes(eg, codes...)
	//判断自定义是不是存在邀请码了
	customTmp, _ := db.UserProfileFindByCustomInviteCodes(eg, codes...)
	//循环生成的邀请码 判断tmp里有没有这个邀请码 如果邀请码没有就赋值 再判断是否存在 存在就清空
	for _, v := range codes {
		if code != "" { //如果存在并且数据库没有就跳过
			continue
		}
		code = v
		for _, v1 := range *tmp {
			//如果存在就清空
			if v1.InviteCode == v {
				code = ""
			}
		}
		for _, v1 := range *customTmp {
			//如果存在就清空
			if v1.CustomInviteCode == v {
				code = ""
			}
		}
	}
	//如果都没有就继续加一位继续查
	if code == "" {
		return returnCode(eg, l+1, types, num+1)
	}
	return code
}
