package model

type OrdList struct {
	OrdId               int64   `xorm:"pk autoincr BIGINT(20)" json:"ord_id"`
	Uid                 int     `xorm:"not null index INT(10)" json:"uid"`
	PvdOid              string  `xorm:"not null index(IDX_PVD) VARCHAR(50)" json:"pvd_oid"`
	ParentOrdId         int64   `xorm:" BIGINT(20)" json:"parent_ord_id"`
	Pvd                 string  `xorm:"not null default '' index(IDX_PVD) index(IDX_PVD_ITEM) VARCHAR(8)" json:"pvd"`
	ItemId              string  `xorm:"not null default '' index(IDX_PVD_ITEM) VARCHAR(50)" json:"item_id"`
	ItemNum             int     `xorm:"not null default 1 TINYINT(3)" json:"item_num"`
	ItemPrice           float64 `xorm:"not null default 0.00 FLOAT(10,2)" json:"item_price"`
	ItemCommissionRate  float64 `xorm:"not null default 0.00 FLOAT(6,4)" json:"item_commission_rate"`
	PaidPrice           float64 `xorm:"not null default 0.00 FLOAT(10,2)" json:"paid_price"`
	CostPrice           float64 `xorm:"not null default 0.00 FLOAT(10,2)" json:"cost_price"`
	OrderType           int     `xorm:"not null default 0 TINYINT(1)" json:"order_type"`
	PriceType           int     `xorm:"not null default 0 INT(1)" json:"price_type"`
	OrderCompare        int     `xorm:"not null default 0 TINYINT(1)" json:"order_compare"`
	SubsidyFee          float64 `xorm:"not null default 0.00 FLOAT(8,2)" json:"subsidy_fee"`
	SubsidyRate         float64 `xorm:"not null default 0.0000 FLOAT(10,4)" json:"subsidy_rate"`
	UserCommission      float64 `xorm:"not null default 0.000 FLOAT(8,3)" json:"user_commission"`
	UserCommissionRate  float64 `xorm:"not null default 0.0000 FLOAT(6,4)" json:"user_commission_rate"`
	PvdCommission       float64 `xorm:"not null default 0.0000 FLOAT(8,4)" json:"pvd_commission"`
	PvdCommissionRate   float64 `xorm:"not null default 0.0000 FLOAT(6,4)" json:"pvd_commission_rate"`
	SysCommission       float64 `xorm:"not null default 0.0000 FLOAT(8,4)" json:"sys_commission"`
	SysCommissionRate   float64 `xorm:"not null default 0.0000 FLOAT(6,4)" json:"sys_commission_rate"`
	PlanCommissionId    int     `xorm:"not null default 0 INT(10)" json:"plan_commission_id"`
	PlanCommissionState int     `xorm:"not null default 0 TINYINT(1)" json:"plan_commission_state"`
	Reason              string  `xorm:"not null default '' VARCHAR(32)" json:"reason"`
	State               int     `xorm:"not null default 0 TINYINT(1)" json:"state"`
	LockState           int     `xorm:"not null default 0 TINYINT(1)" json:"lock_state"`
	CreateAt            int     `xorm:"not null default 0 INT(10)" json:"create_at"`
	UpdateAt            int     `xorm:"not null default 0 INT(11)" json:"update_at"`
	ConfirmAt           int     `xorm:"not null default 0 INT(10)" json:"confirm_at"`
	PvdSettleAt         int     `xorm:"not null default 0 INT(10)" json:"pvd_settle_at"`
	SettleAt            int     `xorm:"not null default 0 INT(10)" json:"settle_at"`
	SubsidyAt           int     `xorm:"not null default 0 INT(10)" json:"subsidy_at"`
	BenefitList         string  `xorm:"not null default '' index VARCHAR(200)" json:"benefit_list"`
	BenefitAll          float64 `xorm:"not null default 0.00 FLOAT(8,2)" json:"benefit_all"`
	Data                string  `xorm:"not null default '' VARCHAR(2000)" json:"data"`
	UpdateFrom          int     `xorm:"not null default 0 TINYINT(1)" json:"update_from"`
	CreateFrom          int     `xorm:"not null default 0 TINYINT(1)" json:"create_from"`
	PvdPid              string  `xorm:"not null default '' index VARCHAR(100)" json:"pvd_pid"`
	UserReturnMoney     float64 `xorm:"not null default 0.000 FLOAT(8,3)" json:"user_return_money"`
	ReturnMoneySettleAt int     `xorm:"not null default 0 INT(10)" json:"return_money_settle_at"`
	IsSetReduce         int     `json:"is_set_reduce" xorm:"default 0 comment('小口袋定制设置退回 0否 1是') INT(1)"`
}
