package model

import (
	"time"
)

type User struct {
	Uid           int       `json:"uid" xorm:"not null pk autoincr comment('主键ID') INT(10)"`
	Username      string    `json:"username" xorm:"not null default '' comment('用户名') index VARCHAR(50)"`
	Password      string    `json:"password" xorm:"not null default '' comment('密码') CHAR(32)"`
	Email         string    `json:"email" xorm:"not null default '' comment('邮箱') VARCHAR(128)"`
	Phone         string    `json:"phone" xorm:"not null default '' comment('联系电话') VARCHAR(20)"`
	Nickname      string    `json:"nickname" xorm:"not null default '' comment('昵称') VARCHAR(20)"`
	Level         int       `json:"level" xorm:"not null default 0 comment('用户等级id') INT(11)"`
	InviteTotal   int       `json:"invite_total" xorm:"not null default 0 comment('直推邀请总人数') INT(11)"`
	LevelArriveAt time.Time `json:"level_arrive_at" xorm:"not null default CURRENT_TIMESTAMP comment('到达该等级的时间') TIMESTAMP"`
	LevelExpireAt time.Time `json:"level_expire_at" xorm:"not null default CURRENT_TIMESTAMP comment('该等级过期时间') TIMESTAMP"`
	CreateAt      time.Time `json:"create_at" xorm:"created not null default CURRENT_TIMESTAMP comment('创建时间') TIMESTAMP"`
	UpdateAt      time.Time `json:"update_at" xorm:"updated default CURRENT_TIMESTAMP comment('最后修改资料时间') TIMESTAMP"`
	LastLoginAt   time.Time `json:"last_login_at" xorm:"default CURRENT_TIMESTAMP comment('最近登录时间') TIMESTAMP"`
	DeleteAt      int       `json:"delete_at" xorm:"not null default 0 comment('是否删除；0未删除；1已删除') TINYINT(1)"`
	State         int       `json:"state" xorm:"not null default 1 comment('0未激活,1正常,2冻结,3删除') TINYINT(1)"`
	LastLoginIp   string    `json:"last_login_ip" xorm:"not null default '' comment('最后登录IP') VARCHAR(64)"`
	RegisterIp    string    `json:"register_ip" xorm:"not null default '' comment('注册IP') VARCHAR(64)"`
}
