package db

import (
	"applet/app/db"
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/super_cloud_issuance/db/official/model"
	"errors"
	"fmt"
	"reflect"
)

// BatchSelectCloudIssuanceMasterBuyOrd 批量查询数据 TODO::和下面的方法重复了，建议采用下面的 `CloudIssuanceMasterBuyOrdFindByParams` 方法
func BatchSelectCloudIssuanceMasterBuyOrd(params map[string]interface{}) (*[]model.SuperCloudIssuanceMasterBuyOrd, error) {
	var CloudIssuanceMasterBuyOrdData []model.SuperCloudIssuanceMasterBuyOrd
	if err := db.Db.In(utils.AnyToString(params["key"]), params["value"]).
		Find(&CloudIssuanceMasterBuyOrdData); err != nil {
		return nil, logx.Warn(err)
	}
	return &CloudIssuanceMasterBuyOrdData, nil
}

// CloudIssuanceMasterBuyOrdInsert 插入单条数据
func CloudIssuanceMasterBuyOrdInsert(CloudIssuanceMasterBuyOrd *model.SuperCloudIssuanceMasterBuyOrd) (int, error) {
	_, err := db.Db.InsertOne(CloudIssuanceMasterBuyOrd)
	if err != nil {
		return 0, err
	}
	return CloudIssuanceMasterBuyOrd.Id, nil
}

// BatchAddCloudIssuanceMasterBuyOrd 批量新增数据
func BatchAddCloudIssuanceMasterBuyOrd(CloudIssuanceMasterBuyOrdData []*model.SuperCloudIssuanceMasterBuyOrd) (int64, error) {
	affected, err := db.Db.Insert(CloudIssuanceMasterBuyOrdData)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func GetCloudIssuanceMasterBuyOrdCount() int {
	var CloudIssuanceMasterBuyOrd model.SuperCloudIssuanceMasterBuyOrd
	session := db.Db.Where("")
	count, err := session.Count(&CloudIssuanceMasterBuyOrd)
	if err != nil {
		return 0
	}
	return int(count)
}

// CloudIssuanceMasterBuyOrdDelete 删除记录
func CloudIssuanceMasterBuyOrdDelete(id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return db.Db.In("id", id).Delete(model.SuperCloudIssuanceMasterBuyOrd{})
	} else {
		return db.Db.Where("id = ?", id).Delete(model.SuperCloudIssuanceMasterBuyOrd{})
	}
}

// CloudIssuanceMasterBuyOrdUpdate 更新记录
func CloudIssuanceMasterBuyOrdUpdate(id interface{}, CloudIssuanceMasterBuyOrd *model.SuperCloudIssuanceMasterBuyOrd, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = db.Db.Where("id=?", id).Cols(forceColums...).Update(CloudIssuanceMasterBuyOrd)
	} else {
		affected, err = db.Db.Where("id=?", id).Update(CloudIssuanceMasterBuyOrd)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

// CloudIssuanceMasterBuyOrdGetOneByParams 通过传入的参数查询数据(单条)
func CloudIssuanceMasterBuyOrdGetOneByParams(params map[string]interface{}) (*model.SuperCloudIssuanceMasterBuyOrd, error) {
	var m model.SuperCloudIssuanceMasterBuyOrd
	var query = fmt.Sprintf("%s =?", params["key"])
	if has, err := db.Db.Where(query, params["value"]).Get(&m); err != nil || has == false {
		return nil, logx.Error(err)
	}
	return &m, nil
}

// CloudIssuanceMasterBuyOrdFindByParams 通过传入的参数查询数据(多条)
func CloudIssuanceMasterBuyOrdFindByParams(params map[string]interface{}) (*[]model.SuperCloudIssuanceMasterBuyOrd, error) {
	var m []model.SuperCloudIssuanceMasterBuyOrd
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if params["key"] == nil {
		//查询全部数据
		err := db.Db.Find(&m)
		if err != nil {
			return nil, logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := db.Db.In(utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := db.Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, logx.Error(err)
			}
			return &m, nil
		}

	}
}
