package db

import (
	"applet/app/db"
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/super_cloud_issuance/db/official/model"
	"errors"
	"fmt"
	"reflect"
)

// SuperCloudIssuanceRobotRecordsInsert 插入单条数据
func SuperCloudIssuanceRobotRecordsInsert(SuperCloudIssuanceRobotRecords *model.SuperCloudIssuanceRobotRecords) (int, error) {
	_, err := db.Db.InsertOne(SuperCloudIssuanceRobotRecords)
	if err != nil {
		return 0, err
	}
	return SuperCloudIssuanceRobotRecords.Id, nil
}

// SuperCloudIssuanceRobotRecordsGetOneByParams 通过传入的参数查询数据(单条)
func SuperCloudIssuanceRobotRecordsGetOneByParams(params map[string]interface{}) (*model.SuperCloudIssuanceRobotRecords, error) {
	var m model.SuperCloudIssuanceRobotRecords
	var query = fmt.Sprintf("%s =?", params["key"])
	if has, err := db.Db.Where(query, params["value"]).Get(&m); err != nil || has == false {
		return nil, logx.Error(err)
	}
	return &m, nil
}

// SuperCloudIssuanceRobotRecordsFindByParams 通过传入的参数查询数据(多条)
func SuperCloudIssuanceRobotRecordsFindByParams(params map[string]interface{}) (*[]model.SuperCloudIssuanceRobotRecords, error) {
	var m []model.SuperCloudIssuanceRobotRecords
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if params["key"] == nil {
		//查询全部数据
		err := db.Db.Find(&m)
		if err != nil {
			return nil, logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := db.Db.In(utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := db.Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, logx.Error(err)
			}
			return &m, nil
		}

	}
}
