package enum

type CloudIssuanceMethodName string

const (
	RobotCreateMethodName               = "itaoke.robot.create.get"
	QrcodeMacLoginMethodName            = "itaoke.robot.qrcode.maclogin"
	RobotAsyncMacLoginMethodName        = "itaoke.robot.async.mlogin"
	RobotForceOfflineMethodName         = "itaoke.robot.force.offline"
	RobotSecondLoginMethodName          = "itaoke.robot.second.login"
	RobotChangeMethodName               = "itaoke.robot.change.get"
	RobotResetMethodName                = "itaoke.robot.reset.get"
	RobotRoomListMethodName             = "itaoke.robot.room.list"
	RobotGroupListMethodName            = "itaoke.robot.group.list"
	RobotRoomDetailMethodName           = "itaoke.robot.room.detail"
	RobotMacGetChatRoomMemberMethodName = "itaoke.robot.macget.chatroommember"
	RobotMacSendCardMethodName          = "itaoke.robot.macsend.card"
	RobotMacSendUriMethodName           = "itaoke.robot.macsend.image"
	RobotMacSendTextMethodName          = "itaoke.robot.macsend.text"
	RobotMacSendRecvImageMethodName     = "itaoke.robot.macsend.recvimage"
	RobotMacSendRecvViedoMethodName     = "itaoke.robot.macsend.recvviedo"
	RobotMacRepeatCircleMethodName      = "itaoke.robot.macrepeat.circle"
	RobotMacSendAppMethodName           = "itaoke.robot.macsend.app"
	RobotMacSendCircleMethodName        = "itaoke.robot.macsend.circle"
)

func (gt CloudIssuanceMethodName) String() string {
	switch gt {
	case RobotCreateMethodName:
		return "云发单添加机器人"
	case QrcodeMacLoginMethodName:
		return "获取登录二维码"
	case RobotAsyncMacLoginMethodName:
		return "循环是否登陆"
	case RobotForceOfflineMethodName:
		return "强制下线"
	case RobotSecondLoginMethodName:
		return "二次登录(阻塞式)"
	case RobotChangeMethodName:
		return "机器人修改/续费"
	case RobotResetMethodName:
		return "重置机器人"
	case RobotRoomListMethodName:
		return "获取群列表"
	case RobotGroupListMethodName:
		return "获取群列表(优惠狗端)"
	case RobotRoomDetailMethodName:
		return "获取群详情"
	case RobotMacGetChatRoomMemberMethodName:
		return "获取群成员"
	case RobotMacSendCardMethodName:
		return "发链接消息"
	case RobotMacSendUriMethodName:
		return "根据url发图"
	case RobotMacSendTextMethodName:
		return "发文本消息"
	case RobotMacSendRecvImageMethodName:
		return "转发图片(xml版)"
	case RobotMacSendRecvViedoMethodName:
		return "转发视频(xml版)"
	case RobotMacRepeatCircleMethodName:
		return "朋友圈转发"
	case RobotMacSendAppMethodName:
		return "转发小程序等XML"
	case RobotMacSendCircleMethodName:
		return "发送朋友圈"
	default:
		return "未知"
	}
}

type CloudIssuanceLoginStatus int

const (
	NotLogin     = 0
	AlreadyLogin = 1
)

func (gt CloudIssuanceLoginStatus) String() string {
	switch gt {
	case NotLogin:
		return "未登录"
	case AlreadyLogin:
		return "已登录"
	default:
		return "未知"
	}
}
