package md

// AliPayCallback 支付宝的回调结构体
type AliPayCallback struct {
	AppID          string `json:"app_id"`
	AuthAppID      string `json:"auth_app_id"`
	BuyerID        string `json:"buyer_id"`
	BuyerLogonID   string `json:"buyer_logon_id"`
	BuyerPayAmount string `json:"buyer_pay_amount"`
	Charset        string `json:"charset"`
	FundBillList   string `json:"fund_bill_list"`
	GmtCreate      string `json:"gmt_create"`
	GmtPayment     string `json:"gmt_payment"`
	InvoiceAmount  string `json:"invoice_amount"`
	OrderType      string `json:"order_type"`
	MasterID       string `json:"master_id"`
	NotifyID       string `json:"notify_id"`
	NotifyTime     string `json:"notify_time"`
	NotifyType     string `json:"notify_type"`
	OutTradeNo     string `json:"out_trade_no"`
	PassbackParams string `json:"passback_params"`
	PointAmount    string `json:"point_amount"`
	ReceiptAmount  string `json:"receipt_amount"`
	SellerEmail    string `json:"seller_email"`
	SellerID       string `json:"seller_id"`
	Sign           string `json:"sign"`
	SignType       string `json:"sign_type"`
	Subject        string `json:"subject"`
	TotalAmount    string `json:"total_amount"`
	TradeNo        string `json:"trade_no"`
	TradeStatus    string `json:"trade_status"`
	Version        string `json:"version"`
	PayMethod      string `json:"pay_method"`
}

type AliPayPayParams struct {
	Subject   string `json:"subject" binding:"required"`
	Amount    string `json:"amount" binding:"required"`
	OrderType string `json:"order_type" binding:"required"`
	OrdId     string `json:"ord_id"`
	Phone     string `json:"phone"`
}
type PayData struct {
	PayAppCertSn          string `json:"pay_app_cert_sn"`
	PayAlipayRootCertSn   string `json:"pay_alipay_root_cert_sn"`
	PayAlipayrsaPublicKey string `json:"pay_alipayrsa_public_key"`
	PayAliUseType         string `json:"pay_ali_use_type"`
	PriKey                string `json:"pay_ali_new_private_key"`
}
type UserCertifyParams struct {
	RealName    string `json:"real_name" `
	IdentityNum string `json:"identity_num" `
	OrdId       string `json:"ord_id"`
	CertifyId   string `json:"certify_id"`
	Uid         string `json:"uid"`
}

type UserCertifyRequest struct {
	OrderId     string `json:"order_id"` //支付订单
	RealName    string `json:"real_name" `
	IdentityNum string `json:"identity_num" `
	CertifyId   string `json:"certify_id"`
	Uid         string `json:"uid"`
}
