package md

// 用户拥有上传权限的目录, 目录ID

const (
	FILE_DIR_FEEDBACK = "feedback"
	FILE_DIR_AVATAR   = "avatar"
	FILE_DIR_QRCODE   = "qrcode"
	FILE_DIR_STYLE    = "style"
)

var (
	FileUserDir = map[string]string{
		FILE_DIR_FEEDBACK: "4", // 用户反馈
		FILE_DIR_AVATAR:   "5", // 用户头像
		FILE_DIR_QRCODE:   "6", // 用户微信二维码
		FILE_DIR_STYLE:    "7", // 用户样式
	}
)

// 文件回调信息
type FileCallback struct {
	Uid      string `json:"uid"`
	DirId    string `json:"dir_id"`
	Provider string `json:"provider"` // 供应商
	FileName string `json:"fname"`    // 原文件名
	FileSize string `json:"fsize"`
	Hash     string `json:"hash"`
	Bucket   string `json:"bucket"`
	Mime     string `json:"mime"`
	Width    string `json:"w,omitempty"`
	Height   string `json:"h,omitempty"`
	Time     string `json:"time"` // 默认一个小时内要上传完毕,否则超时
	Sign     string `json:"sign"` // 签名
}

type FileList struct {
	Path     string `json:"path"`
	DirId    int    `json:"dir_id"`
	FileName string `json:"f_name"`   // 显示名称
	StgName  string `json:"stg_name"` // 存储名字
	Ext      string `json:"ext"`      // 后缀名, png,jpg等
	FileSize string `json:"f_size"`
	Provider string `json:"provider"` // 存储供应商
	Hash     string `json:"hash"`
	Bucket   string `json:"bucket"`
	Width    int    `json:"w"`
	Height   int    `json:"h"`
	Mime     string `json:"mime"`
	IsAdm    bool   `json:"is_adm"` //是否管理后台上传
	IsDir    bool   `json:"is_dir"` //是否文件夹
	CreateAt int    `json:"create_at"`
	Url      string `json:"url"`
}
