package md

type CurlResponse struct {
	Status string      `json:"status"`
	Data   interface{} `json:"data"`
	Msg    string      `json:"msg"`
}

type CurlResponseForCircle struct { //朋友圈相关接口响应
	Code    string      `json:"code"`
	Data    interface{} `json:"data"`
	Message string      `json:"message"`
}

type RobotCreateRequest struct {
	Month       int    `json:"month"`       //新增月份，默认1
	RobotType   string `json:"robot_type"`  //机器人类型 1 发单机器人 2转发机器人 3 返利机器人 4全能机器人 5小型机器人 6发圈机器人
	WechatRobot string `json:"wechatrobot"` //微信号
	Remark      string `json:"remark"`      //备注
}
type RobotCreateResponse struct {
	Id          float64 `json:"id"`
	Uid         float64 `json:"uid"`
	WechatRobot string  `json:"wechatrobot"`
	//NickName    string  `json:"nickname"`
	LoginStatus float64 `json:"login_status"`
	EndTime     int64   `json:"end_time"` //到期时间
	Remark      string  `json:"remark"`
	WcId        string  `json:"wc_id"`      //微信实例id
	IsEnabled   float64 `json:"is_enabled"` //0 正常 1暂停 2已过期
}

type RobotQrcodeMacLoginRequest struct {
	RobotId int `json:"robot_id"` //机器人id
}
type RobotQrcodeMacLoginResponse struct {
	WId       string `json:"wId"` //实例id
	QrCodeUrl string `json:"qrCodeUrl"`
}

type RobotAsyncMacLoginRequest struct {
	WId     string `json:"wId"`      //实例id
	RobotId int    `json:"robot_id"` //机器人id
}
type RobotAsyncMacLoginResponse struct {
	WId      string `json:"wId"`      //实例id
	WcId     string `json:"wcId"`     //微信id
	NickName string `json:"nickName"` //微信昵称
	HeadUrl  string `json:"headUrl"`  //微信头像
}

type RobotForceOfflineRequest struct {
	RobotId int `json:"robot_id"` //机器人id
}

type RobotSecondLoginRequest struct {
	RobotId int `json:"robot_id"` //机器人id
}
type RobotSecondLoginResponse struct {
	WId      string `json:"wId"`      //实例id
	WcId     string `json:"wcId"`     //微信id
	NickName string `json:"nickName"` //微信昵称
	HeadUrl  string `json:"headUrl"`  //微信头像
}

type RobotChangeRequest struct {
	RobotId int `json:"robot_id"` //机器人id
	Month   int `json:"month"`    //续费月数
	//WechatRobot int `json:"wechatrobot"` //微信号 更换号的时候传 (TODO::暂时用不到)
}
type RobotChangeResponse struct {
	Uid         float64 `json:"uid"`
	WechatRobot string  `json:"wechatrobot"`
	LoginStatus float64 `json:"login_status"`
	EndTime     int64   `json:"end_time"` //到期时间
	Remark      string  `json:"remark"`
	WcId        string  `json:"wc_id"`      //微信实例id
	IsEnabled   float64 `json:"is_enabled"` //0 正常 1暂停 2已过期
}

type RobotResetRequest struct {
	RobotId int `json:"robot_id"` //机器人id
}

type RobotRoomListRequest struct {
	RobotId int `json:"robot_id"` //机器人id
	//RoomContactSeq int `json:"room_contact_seq"` // 首次传0, 后面接口返回, 不传默认全部
	//WxContactSeq   int `json:"wx_contact_seq"`   // 首次传0, 后面接口返回, 不传默认全部
}
type RobotRoomListResponse []string

type RobotRoomDetailRequest struct {
	RobotId int    `json:"robot_id"` //机器人id
	RoomId  string `json:"room_id"`  // 群的id ,多个用逗号隔开
}
type RobotRoomDetailResponse struct {
	ChatRoomId      string           `json:"chatRoomId"`
	NickName        string           `json:"nickName"`
	ChatRoomOwner   string           `json:"chatRoomOwner"`
	BigHeadImgUrl   string           `json:"bigHeadImgUrl"`
	SmallHeadImgUrl string           `json:"smallHeadImgUrl"`
	V1              string           `json:"v1"`
	MemberCount     string           `json:"memberCount"`
	ChatRoomMembers []ChatRoomMember `json:"chatRoomMembers"`
}
type ChatRoomMember struct {
	UserName        string `json:"userName"`
	NikeName        string `json:"nikeName"`
	InviterUserName string `json:"inviterUserName"`
}

type RobotMacSendCardRequest struct {
	RobotId     int    `json:"robot_id"`    //机器人id
	WxId        string `json:"wx_id"`       //发送微信好友/群id。一般wxid_开头
	Title       string `json:"title"`       //标题
	Url         string `json:"url"`         //链接
	Description string `json:"description"` //描述
	ThumbUrl    string `json:"thumbUrl"`    //图片
}

type RobotMacSendUriRequest struct {
	RobotId int    `json:"robot_id"` //机器人id
	WxId    string `json:"toWxId"`   //发送微信好友/群id。一般wxid_开头
	PicUrl  string `json:"pic_url"`  //图片地址
}

type RobotMacSendTextRequest struct {
	RobotId int    `json:"robot_id"` //机器人id
	WxId    string `json:"toWxId"`   //发送微信好友/群id。一般wxid_开头
	Content string `json:"content"`  //内容
}

type RobotMacSendRecvImageRequest struct {
	RobotId int    `json:"robot_id"` //机器人id
	WxId    string `json:"wx_id"`    //发送微信好友/群id。一般wxid_开头
	Content string `json:"content"`  //消息xml内容
}

type RobotMacSendRecvVideoRequest struct {
	RobotId int    `json:"robot_id"` //机器人id
	WxId    string `json:"wx_id"`    //发送微信好友/群id。一般wxid_开头
	Content string `json:"content"`  //消息xml内容
}

type RobotMacSendCircleRequest struct {
	RobotId int    `json:"robot_id"` //机器人id
	PicUrl  string `json:"pic_url"`  //图片url，多个请用;分隔
	Content string `json:"content"`  //文案
}

type GetUserInfoResponse struct {
	User                interface{} `json:"user"`
	State               int         `json:"state"`                  //状态(0:未开通 1:未绑定 2:未登录 3:已登录)
	EndTime             string      `json:"end_time"`               //到期时间
	OpenTime            string      `json:"open_time"`              //开通时间
	BalanceDay          int         `json:"balance_day"`            //剩余天数
	WcNickname          string      `json:"wc_nickname"`            //微信昵称
	WcHeadUrl           string      `json:"wc_head_url"`            //微信头像
	GroupNum            int         `json:"group_num"`              //最大群数
	AlreadyBindGroupNum int         `json:"already_bind_group_num"` //已绑定群数
}

type RobotMacGetChatRoomMemberRequest struct {
	RobotId int    `json:"robot_id"` //机器人id
	RoomId  string `json:"room_id"`  // 群的id
}

type RobotMacGetChatRoomMemberResponseV1 struct {
	UserName        string `json:"userName"`        //微信号
	NickName        string `json:"nickName"`        //昵称
	DisplayName     string `json:"displayName"`     //群昵称
	BigHeadImgUrl   string `json:"bigHeadImgUrl"`   //头像
	SmallHeadImgUrl string `json:"smallHeadImgUrl"` //头像(缩略图)
	InviteUser      string `json:"inviteUser"`      //邀请人微信号
}
type RobotMacGetChatRoomMemberResponse struct {
	UserName        string `json:"user_name"`          //微信号
	NickName        string `json:"nick_name"`          //昵称
	DisplayName     string `json:"display_name"`       //群昵称
	BigHeadImgUrl   string `json:"big_head_img_url"`   //头像
	SmallHeadImgUrl string `json:"small_head_img_url"` //头像(缩略图)
	InviteUser      string `json:"invite_user"`        //邀请人微信号
}
