package md

type MultiNav struct {
	CateName           string      `json:"cate_name"`
	CateTag            string      `json:"cate_tag"`
	Data               CommModData `json:"data"`
	ID                 string      `json:"id"`
	Img                string      `json:"img"`
	ImgURL             string      `json:"img_url"`
	Index              int64       `json:"index"`
	IsEnd              string      `json:"is_end"`
	IsJump             string      `json:"is_jump"`
	Name               string      `json:"name"`
	RequiredLogin      string      `json:"required_login"`
	RequiredTaobaoAuth string      `json:"required_taobao_auth"`
	RightIcon          string      `json:"right_icon"`
	RightIconURL       string      `json:"right_icon_url"`
	SkipIdentifier     string      `json:"skip_identifier"`
	SkipName           string      `json:"skip_name"`
	SubTitle           string      `json:"sub_title"`
	Title              string      `json:"title"`
	TypeListKey        string      `json:"type_list_key"`
	URL                string      `json:"url"`
}

// 公共data数据
type CommModData struct {
	AdvInfo          string         `json:"adv_info"`
	AlipayUrl        string         `json:"alipay_url"`
	AlipayAppid      string         `json:"alipay_appid"`
	AdvType          string         `json:"adv_type"`
	IsCanBuy         string         `json:"is_can_buy"`
	IsShowCouponList string         `json:"is_show_coupon_list"`
	UserCouponAmount string         `json:"user_coupon_amount"`
	Coupon           string         `json:"coupon"`
	Url              string         `json:"url"`
	AppId            string         `json:"app_id"`
	ActivityId       string         `json:"activity_id"`
	Id               string         `json:"id"`
	AdName           string         `json:"ad_name"`
	AndroidAdID      string         `json:"android_ad_id"`
	AndroidMediaID   string         `json:"android_media_id"`
	AutoClickAd      string         `json:"auto_click_ad"`
	Autoplay         string         `json:"autoplay"`
	BrandID          string         `json:"brand_id"`
	Conditions       string         `json:"conditions"`
	CreateAt         string         `json:"create_at"`
	EndTime          string         `json:"end_time"`
	Img              string         `json:"img"`
	IosAdID          string         `json:"ios_ad_id"`
	IosMediaID       string         `json:"ios_media_id"`
	IsRecommend      interface{}    `json:"is_recommend"`
	LevelLimitID     string         `json:"level_limit_id"`
	LevelLimitName   string         `json:"level_limit_name"`
	LevelWeight      string         `json:"level_weight"`
	NeedLocation     int64          `json:"need_location"`
	SdkType          string         `json:"sdk_type"`
	Type             string         `json:"type"`
	SourceType       string         `json:"source_type"`
	StartTime        string         `json:"start_time"`
	UpdateAt         string         `json:"update_at"`
	VisitCount       string         `json:"visit_count"`
	CountingDown     string         `json:"counting_down" `
	FunctionSkipType string         `json:"function_skip_type"`
	OpenType         string         `json:"open_type" ` //app 应用内打开  browser 系统浏览器打开
	GoodsId          string         `json:"goods_id"`
	GoodsType        string         `json:"goods_type"`
	SecondAdvList    AdvCommModData `json:"second_adv_list"`
	ThirdAdvList     AdvCommModData `json:"third_adv_list"`
	LevelType        string         `json:"level_type"`
	//IsShowConditionPop string      `json:"is_show_condition_pop"`
	//ShowConditionStr   string      `json:"show_condition_str"`
	//ShowConditionSkip  SkipData    `json:"show_condition_skip"`
}

// 公共data数据
type AdvCommModData struct {
	Id             string `json:"id"`
	AdName         string `json:"ad_name"`
	AndroidAdID    string `json:"android_ad_id"`
	AndroidMediaID string `json:"android_media_id"`
	AutoClickAd    string `json:"auto_click_ad"`
	Autoplay       string `json:"autoplay"`
	IosAdID        string `json:"ios_ad_id"`
	IosMediaID     string `json:"ios_media_id"`
	SdkType        string `json:"sdk_type"`
	AdvType        string `json:"adv_type"`
}
type ShowCondition struct {
	IsShowConditionPop string   `json:"is_show_condition_pop"`
	ShowConditionStr   string   `json:"show_condition_str"`
	ShowConditionSkip  SkipData `json:"show_condition_skip"`
}
type NextCommModData struct {
	Url            string      `json:"url"`
	AppId          string      `json:"app_id"`
	AlipayUrl      string      `json:"alipay_url"`
	AlipayAppid    string      `json:"alipay_appid"`
	ActivityId     string      `json:"activity_id"`
	Id             string      `json:"id"`
	AdName         string      `json:"ad_name"`
	AndroidAdID    string      `json:"android_ad_id"`
	AndroidMediaID string      `json:"android_media_id"`
	AutoClickAd    string      `json:"auto_click_ad"`
	Autoplay       string      `json:"autoplay"`
	BrandID        string      `json:"brand_id"`
	Conditions     string      `json:"conditions"`
	CreateAt       string      `json:"create_at"`
	EndTime        string      `json:"end_time"`
	Img            string      `json:"img"`
	IosAdID        string      `json:"ios_ad_id"`
	IosMediaID     string      `json:"ios_media_id"`
	IsRecommend    interface{} `json:"is_recommend"`
	LevelLimitID   string      `json:"level_limit_id"`
	LevelLimitName string      `json:"level_limit_name"`
	LevelWeight    string      `json:"level_weight"`
	NeedLocation   int64       `json:"need_location"`
	SdkType        string      `json:"sdk_type"`
	SourceType     string      `json:"source_type"`
	StartTime      string      `json:"start_time"`
	UpdateAt       string      `json:"update_at"`
	VisitCount     string      `json:"visit_count"`
	CountingDown   string      `json:"counting_down" `
	LevelType      string      `json:"level_type"`
	OpenType       string      `json:"open_type" ` //app 应用内打开  browser 系统浏览器打开
}
type SkipData struct {
	SkipName           string          `json:"skip_name"`
	SkipIdentifier     string          `json:"skip_identifier"`
	RequiredLogin      string          `json:"required_login"`
	RequiredTaobaoAuth string          `json:"required_taobao_auth"`
	IsJump             string          `json:"is_jump"`
	Data               NextCommModData `json:"data"`
}

type NewSelectList struct {
	Key  string `json:"key"`
	Name string `json:"name"`
}
type NewValList struct {
	Val  string `json:"val"`
	Name string `json:"name"`
}
