package md

const (
	BALANCE_PAY               = "balance_pay"
	ALIPAY                    = "alipay"
	WX_PAY                    = "wxpay"
	FB_PAY_ALI                = "fb_pay_ali"
	FB_PAY_WX                 = "fb_pay_wx"
	FB_PAY_WX_SUB             = "fb_pay_wx_sub"
	SuperCloudIssuancePackage = "super_cloud_issuance_package"
	ONE_CALLBACK_URL          = "%s/api/v1/superCloudIssuance/pay/callback?master_id=%s&order_type=%s&pay_method=%s"
)

var NeedPayPart = map[string]string{
	SuperCloudIssuancePackage: "云发单套餐",
}

var PayMethodIDToName = map[int]string{
	1:  "余额支付",
	2:  "支付宝支付",
	3:  "微信支付",
	18: "乐刷支付宝支付",
	19: "乐刷微信支付",
}
var PayStateToName = map[int]string{
	0: "未支付",
	1: "已支付",
	2: "支付失败",
}

// PayMethodIDs 支付方式ID
var PayMethodIDs = map[string]int{
	BALANCE_PAY:   1,
	ALIPAY:        2,
	WX_PAY:        3,
	FB_PAY_ALI:    18,
	FB_PAY_WX:     19,
	FB_PAY_WX_SUB: 19,
}

type BuyPackageReq struct {
	PackageId int `json:"package_id"` //套餐id
}

type PayRechargeResp struct {
	MainOrdId string
	Total     string
	Uid       string
}
