package md

import (
	"applet/app/db/model"
)

type UserInfoResponse struct {
	Avatar        string `json:"avatar"`
	NickName      string `json:"nickname"`
	Gender        string `json:"gender"`
	Birthday      string `json:"birthday"`
	RegisterTime  string `json:"register_time"`
	FileBucketURL string `json:"file_bucket_url"`
	FileFormat    string `json:"file_format"`
	IsNoChange    string `json:"is_no_change"`
	IsUpLoadWx    string `json:"is_upload_wx"`
}

type User struct {
	Info    *model.User
	Profile *model.UserProfile
	Level   *model.UserLevel
	Tags    []string
}

type UserRelation struct {
	Uid     int
	CurUid  int
	Diff    int // 与当前用户级别差
	Level   int // 用户当前等级
	OldDiff int // 旧的级别
}

type UserTree struct {
	Uid      int         `json:"uid"`
	Nickname string      `json:"nickname"`
	Phone    string      `json:"phone"`
	Children []*UserTree `json:"children"`
}
