package svc

import (
	"applet/app/utils"
	"applet/super_cloud_issuance/lib/baidu"
	"applet/super_cloud_issuance/lib/zhimeng"
	"github.com/gin-gonic/gin"
	"github.com/tidwall/gjson"
	"math/rand"
	"strings"
)

func GetContent(c *gin.Context, content string, ProductCopy, ProductTitle,
	ProductOriginalPrice, ProductCouponPrice, ProductCoupon, taokou, shorturl, goodsContent string) string {
	inviteLink := InviteLinks(c)
	user := GetUser(c)
	content = strings.Replace(content, "{商品文案}", ProductCopy, 1)
	content = strings.Replace(content, "{商品标题}", ProductTitle, 1)
	content = strings.Replace(content, "{原价}", ProductOriginalPrice, 1)
	content = strings.Replace(content, "{现价}", ProductCouponPrice, 1)
	content = strings.Replace(content, "{优惠券}", ProductCoupon, 1)
	content = strings.Replace(content, "{文案}", goodsContent, 1)
	if user.Profile.CustomInviteCode != "" {
		content = strings.Replace(content, "{邀请码}", user.Profile.CustomInviteCode, 1)
	} else {
		content = strings.Replace(content, "{邀请码}", user.Profile.InviteCode, 1)
	}
	content = strings.Replace(content, "{邀请注册链接}", inviteLink, 1)
	content = strings.Replace(content, "{下载链接}", ImageFormat(c, SysCfgGet(c, "app_android_download_url")), 1)
	content = strings.Replace(content, "{应用宝下载链接}", SysCfgGet(c, "app_treasure_url"), 1)
	content = strings.Replace(content, "{口令}", taokou, 1)
	content = strings.Replace(content, "{商品链接}", shorturl, 1)

	if taokou != "" {
		content = utils.IntToStr(rand.Intn(9)) + content
	}
	return content
}

func InviteLinks(c *gin.Context) string {
	user := GetUser(c)
	//downLoadRoute := "/#/zy-landing-page/pages/lading-page-download/lading-page-download?invited_code="
	registerRoute := "/#/zy-landing-page/pages/landing-page-login/landing-page-login?invited_code="
	h5Domain := GetWebSiteDomainInfo(c, "wap")
	var inviteLink = ""
	//if user.Profile.CustomInviteCode != "" {
	//	inviteLink = h5Domain + downLoadRoute + user.Profile.CustomInviteCode
	//} else {
	//	inviteLink = h5Domain + downLoadRoute + user.Profile.InviteCode
	//}
	//urlType := gjson.Get(mdata, "url_type").String()
	if user.Profile.CustomInviteCode != "" {
		inviteLink = h5Domain + registerRoute + user.Profile.CustomInviteCode
	} else {
		inviteLink = h5Domain + registerRoute + user.Profile.InviteCode
	}
	//判断生成短链
	inviteLink = CommShareShorUrl(c, inviteLink)
	return inviteLink
}

// 公共处理链接转换短链
func CommShareShorUrl(c *gin.Context, shareUrl string) string {
	val := SysCfgFind(c, "share_link_type")
	if val["share_link_type"] == "1" { //百度短链
		shareUrl, _ = baidu.ShortenUrl(shareUrl)
	} else if val["share_link_type"] == "2" { //快站短链
		shareUrl = KuaiZhanShortURL(c, shareUrl)
	}
	return shareUrl
}

// KuaiZhanShortURL is 快站短链
func KuaiZhanShortURL(c *gin.Context, url string) string {
	args := map[string]interface{}{
		"appkey":     SysCfgGet(c, "third_zm_app_key"),
		"secret_key": SysCfgGet(c, "third_zm_app_key"),
		"url":        utils.Base64StdEncode(url),
	}
	resp, err := zhimeng.Send("kuaizhan", "short_url", args)
	if err != nil {
		return ""
	}
	kurl := gjson.GetBytes(resp, "data.shortUrl").String()
	if kurl == "" {
		kurl = url
	}
	return kurl
}
