package svc

import (
	"applet/app/db"
	"applet/app/db/model"
	"applet/app/utils"
	"applet/app/utils/logx"
	"time"
	"xorm.io/xorm"
)

// 开始写入流水
func FlowInsert(eg *xorm.Engine, uid int, paidPrice string, orderAction int, ordId int64, id int64, goodsId int, ItemTitle string, ordType string, types int, beforeAmount string, afterAmount string) {
	session := eg.NewSession()

	now := time.Now()
	if err := db.FinUserFlowInsertOneWithSession(
		session,
		&model.FinUserFlow{
			Type:         types,
			Uid:          uid,
			Amount:       paidPrice,
			BeforeAmount: beforeAmount,
			AfterAmount:  afterAmount,
			OrdType:      ordType,
			OrdId:        utils.Int64ToStr(ordId),
			OrdAction:    orderAction,
			OrdDetail:    utils.IntToStr(goodsId),
			State:        2,
			OtherId:      id,
			OrdTitle:     ItemTitle,
			OrdTime:      int(now.Unix()),
			CreateAt:     now,
			UpdateAt:     now,
		}); err != nil {
		_ = session.Rollback()
		_ = logx.Warn(err)
		return
	}
}

// 开始写入流水
func SessionFlowInsert(session *xorm.Session, uid int, paidPrice string, orderAction int, ordId int64, id int64, goodsId int, ItemTitle string, ordType string, types int, beforeAmount string, afterAmount string) {
	now := time.Now()
	if err := db.FinUserFlowInsertOneWithSession(
		session,
		&model.FinUserFlow{
			Type:         types,
			Uid:          uid,
			Amount:       paidPrice,
			BeforeAmount: beforeAmount,
			AfterAmount:  afterAmount,
			OrdType:      ordType,
			OrdId:        utils.Int64ToStr(ordId),
			OrdAction:    orderAction,
			OrdDetail:    utils.IntToStr(goodsId),
			State:        2,
			OtherId:      id,
			OrdTitle:     ItemTitle,
			OrdTime:      int(now.Unix()),
			CreateAt:     now,
			UpdateAt:     now,
		}); err != nil {
		_ = session.Rollback()
		_ = logx.Warn(err)
		return
	}
}
