package utils

import (
	"fmt"
	"github.com/gin-gonic/gin"
	"strconv"
	"strings"
)

func GetIntegralPrec(c *gin.Context, sum string) string {
	if sum == "" {
		sum = "0"
	}
	commPrec := c.GetString("integral_prec")
	sum = StrToFormat(c, sum, StrToInt(commPrec))
	ex := strings.Split(sum, ".")
	if len(ex) == 2 && c.GetString("is_show_point") != "1" {
		if StrToFloat64(ex[1]) == 0 {
			sum = ex[0]
		} else {
			val := Float64ToStrByPrec(StrToFloat64(ex[1]), 0)
			keyMax := 0
			for i := 0; i < len(val); i++ {
				ch := string(val[i])
				fmt.Println(StrToInt(ch))
				if StrToInt(ch) > 0 {
					keyMax = i
				}
			}
			valNew := val[0 : keyMax+1]
			sum = ex[0] + "." + strings.ReplaceAll(ex[1], val, valNew)
		}
	}
	return sum
}

func GetCommissionPrec(c *gin.Context, sum string) string {
	if sum == "" {
		sum = "0"
	}
	commPrec := c.GetString("commission_prec")
	sum = StrToFormat(c, sum, StrToInt(commPrec))
	ex := strings.Split(sum, ".")
	if len(ex) == 2 && c.GetString("is_show_point") != "1" {
		if StrToFloat64(ex[1]) == 0 {
			sum = ex[0]
		} else {
			val := Float64ToStrByPrec(StrToFloat64(ex[1]), 0)
			keyMax := 0
			for i := 0; i < len(val); i++ {
				ch := string(val[i])
				fmt.Println(StrToInt(ch))
				if StrToInt(ch) > 0 {
					keyMax = i
				}
			}
			valNew := val[0 : keyMax+1]
			sum = ex[0] + "." + strings.ReplaceAll(ex[1], val, valNew)
		}
	}
	return sum
}
func Float64ToStrByPrec(f float64, prec int) string {
	return strconv.FormatFloat(f, 'f', prec, 64)
}
func StrToFormat(c *gin.Context, s string, prec int) string {
	ex := strings.Split(s, ".")
	if len(ex) == 2 {
		if StrToFloat64(ex[1]) == 0 && c.GetString("is_show_point") != "1" { //小数点后面为空就是不要小数点了
			return ex[0]
		}
		//看取多少位
		str := ex[1]
		str1 := str
		if prec < len(str) {
			str1 = str[0:prec]
		} else {
			for i := 0; i < prec-len(str); i++ {
				str1 += "0"
			}
		}
		if prec > 0 {
			return ex[0] + "." + str1
		} else {
			return ex[0]
		}
	}
	return s
}
